package xmlcaviargui;
import java.awt.geom.*;
import javax.swing.*;
import java.awt.*;

public class Body{
	
	private Circle head,lefthand,righthand,leftfoot,rightfoot;
	private boolean visiblehead=true,
					visiblelefthand=true,
					visiblerighthand=true,
					visibleleftfoot=true,
					visiblerightfoot=true,
					visiblerightshoulder=true,
					visibleleftshoulder=true;
	
    
	private Line2D.Float shoulderLine;	//(right shoulder,left shoulder)
    
	private int gaze=-1;	
	
	public Body(){
		head = null;
		lefthand = null;
		righthand = null;
		leftfoot = null;
		rightfoot = null;
		shoulderLine=null;
		gaze=-1;
	}
	
	public Body(Circle head, Circle righthand, Circle lefthand,Circle rightfoot, Circle leftfoot,
				int gaze, Line2D.Float shoulderLine){
		this.head = head;
		this.rightfoot = rightfoot;
		this.leftfoot = leftfoot;
		this.righthand = righthand;
		this.lefthand = lefthand;	
		this.gaze=gaze;
		this.shoulderLine=shoulderLine;	
	}
	
	public Body cloneBody(){
		Body b=new Body();
		if (this.head!=null)
			b.head=this.head.cloneCircle();
		if (this.lefthand!=null)
			b.lefthand=this.lefthand.cloneCircle();
		if (this.righthand!=null)
			b.righthand=this.righthand.cloneCircle();
		if (this.leftfoot!=null)
			b.leftfoot=this.leftfoot.cloneCircle();
		if (this.rightfoot!=null)
			b.rightfoot=this.rightfoot.cloneCircle();
		if (this.shoulderLine!=null)
			b.shoulderLine=(Line2D.Float)this.shoulderLine.clone();
		b.gaze=this.gaze;
		b.visiblehead=this.visiblehead;
		b.visibleleftfoot=this.visibleleftfoot;
		b.visiblelefthand=this.visiblelefthand;
		b.visibleleftshoulder=this.visibleleftshoulder;
		b.visiblerightfoot=this.visiblerightfoot;
		b.visiblerighthand=this.visiblerighthand;
		b.visiblerightshoulder=this.visiblerightshoulder;		
		return b;		
	}
	
	public void setCirclewithType(Circle circle){
		switch (circle.getType()) {
			case Circle.HEAD: setHead(circle); break;
			case Circle.RIGHTHAND:setRighthand(circle);break;
			case Circle.LEFTHAND:setLefthand(circle);break;
			case Circle.RIGHTFOOT:setRightfoot(circle);break;
			case Circle.LEFTFOOT:setLeftfoot(circle);break;
		}					
	}
	
	public void setCirclewithTypeSpecified(Circle circle,int type){
		if (circle!=null)
			circle.setType(type);
		switch (type) {
			case Circle.HEAD: setHead(circle); break;
			case Circle.RIGHTHAND:setRighthand(circle);break;
			case Circle.LEFTHAND:setLefthand(circle);break;
			case Circle.RIGHTFOOT:setRightfoot(circle);break;
			case Circle.LEFTFOOT:setLeftfoot(circle);break;
		}					
	}	

	private boolean insideBoxCoordinates(int x,int y,Rectangle box){
		if ((x>box.getX()) && (x<(box.getX()+box.getWidth())) 
			&& (y>box.getY()) && (y<(box.getY()+box.getHeight())))	
			return true;
		else
			return false;	
	}	

	public Circle fitCircleInBox(Circle circle, Rectangle box){
		if (insideBoxCoordinates(circle.getX(),circle.getY(),box)==false){
			circle=null;
		}else{
			//System.out.println("box is "+box.getX()+" "+box.getY()+" ancho "+box.getWidth()+" alto "+box.getHeight());
			if ((circle.getX()-circle.getR()) < (box.getX())){
				circle.setR((int)(circle.getX()-box.getX()));
			}
			if ((circle.getX()+circle.getR()) > (box.getX()+box.getWidth())){
				circle.setR((int)(box.getX()+box.getWidth()-circle.getX()));
			}
			if ((circle.getY()-circle.getR()) < (box.getY())){
				circle.setR((int)(circle.getY()-box.getY()));
			}
			if ((circle.getY()+circle.getR()) > (box.getY()+box.getHeight())){
				circle.setR((int)(box.getY()+box.getHeight()-circle.getY()));
			}
			if (circle.getR()<0){
				circle=null;    
			}			
		}		    	
		return circle;
	}

	private Point fitCoordinatestoBox(int x,int y,Rectangle box){
//		System.out.println(" coordinates "+x+" y "+y);
//		System.out.println("box is "+box.getX()+" "+box.getY()+" ancho "+box.getWidth()+" alto "+box.getHeight());
		Point p=null;
		if (x<box.getX())
			x=(int)box.getX();
		if (x>(box.getX()+box.getWidth()))
			x=(int)(box.getX()+box.getWidth());
		if (y<box.getY())
			y=(int)box.getY();
		if (y>(box.getY()+box.getHeight()))
			y=(int)(box.getY()+box.getHeight());
//		System.out.println(" After adjusting coordinates "+x+" y "+y);		
		p=new Point(x,y);
		return p;
	}
	
	private void showMessageNullCircle(String s){
	JOptionPane.showMessageDialog(null,("Circle "+s+" does not fit, reseted to null"),
								  "fitting Warning", JOptionPane.WARNING_MESSAGE);
	}		
	
	public Body fitBodyinBox(Rectangle box){
		if (shoulderLine!=null){
			Point2D right=shoulderLine.getP1();
			Point2D left=shoulderLine.getP2();
			Point r=fitCoordinatestoBox((int)right.getX(),(int)right.getY(),box);
			Point l=fitCoordinatestoBox((int)left.getX(),(int)(left.getY()),box);
			this.shoulderLine=new Line2D.Float((float)r.getX(),(float)r.getY(),(float)l.getX(),(float)l.getY());						
		}else{
			this.visibleleftshoulder=false;
			this.visiblerightshoulder=false;
		}
		if (this.head!=null){
			this.head=fitCircleInBox(this.head,box);
			if (this.head==null){
				showMessageNullCircle("HEAD");
				this.visiblehead=false;
			}
		}
		if (this.righthand!=null){
			this.righthand=fitCircleInBox(this.righthand,box);
			if (this.righthand==null){
				showMessageNullCircle("RIGHT HAND");
				this.visiblerighthand=false;
			}
		}
		if (this.lefthand!=null){
			this.lefthand=fitCircleInBox(this.lefthand,box);
			if (this.lefthand==null){
				showMessageNullCircle("LEFT HAND");
				this.visiblelefthand=false;
			}	
		}
		if (this.rightfoot!=null){	
			this.rightfoot=fitCircleInBox(this.rightfoot,box);
			if (this.rightfoot==null){
				showMessageNullCircle("RIGHT FOOT");
				this.visiblerightfoot=false;
			}
		}
		if (this.leftfoot!=null){
			this.leftfoot=fitCircleInBox(this.leftfoot,box);
			if (this.leftfoot==null){
				showMessageNullCircle("LEFT FOOT");
				this.visibleleftfoot=false;
			}	
		}		
		return this;		
	}
	
	public boolean isNull(){
		boolean isnull=true;
		if ((head!=null) || (lefthand!=null) || (righthand!=null) || (leftfoot!=null) || (rightfoot!=null) 
			|| (shoulderLine!=null) || (gaze!=-1))
				isnull=false;
		return isnull;
	}
	
	public boolean isHeadDraw(){
		if (head!=null)
			return true;
		else
			return false;		
	}
	
	public boolean isRightFootDraw(){
		if (rightfoot!=null)
			return true;
		else
			return false;		
	}	

	public boolean isLeftFootDraw(){
		if (leftfoot!=null)
			return true;
		else
			return false;		
	}	
	
	public boolean isRightHandDraw(){
		if (righthand!=null)
			return true;
		else
			return false;		
	}	

	public boolean isLeftHandDraw(){
		if (lefthand!=null)
			return true;
		else
			return false;		
	}
	
	public boolean isShouldersDraw(){
		if (shoulderLine!=null)
			return true;
		else
			return false;		
	}	

	public boolean isGazeDraw(){
		if (gaze!=-1)
			return true;
		else
			return false;			
	}



	/**
	 * @return
	 */
	public Circle getLeftfoot() {
		return leftfoot;
	}

	/**
	 * @return
	 */
	public Circle getLefthand() {
		return lefthand;
	}

	/**
	 * @return
	 */
	public Circle getRightfoot() {
		return rightfoot;
	}

	/**
	 * @return
	 */
	public Circle getRighthand() {
		return righthand;
	}

	/**
	 * @return
	 */
	public Line2D.Float getShoulderLine() {
		return shoulderLine;
	}

	/**
	 * @param circle
	 */
	public void setLeftfoot(Circle circle) {
		leftfoot = circle;
	}

	/**
	 * @param circle
	 */
	public void setLefthand(Circle circle) {
		lefthand = circle;
	}

	/**
	 * @param circle
	 */
	public void setRightfoot(Circle circle) {
		rightfoot = circle;
	}

	/**
	 * @param circle
	 */
	public void setRighthand(Circle circle) {
		righthand = circle;
	}

	/**
	 * @param float1
	 */
	public void setShoulderLine(Line2D.Float float1) {
		shoulderLine = float1;
	}

	/**
	 * @return Returns the visiblehead.
	 */
	public boolean isVisiblehead() {
		return visiblehead;
	}
	/**
	 * @param visiblehead The visiblehead to set.
	 */
	public void setVisiblehead(boolean visiblehead) {
		this.visiblehead = visiblehead;
	}
	/**
	 * @return Returns the visibleleftfoot.
	 */
	public boolean isVisibleleftfoot() {
		return visibleleftfoot;
	}
	/**
	 * @param visibleleftfoot The visibleleftfoot to set.
	 */
	public void setVisibleleftfoot(boolean visibleleftfoot) {
		this.visibleleftfoot = visibleleftfoot;
	}
	/**
	 * @return Returns the visiblelefthand.
	 */
	public boolean isVisiblelefthand() {
		return visiblelefthand;
	}
	/**
	 * @param visiblelefthand The visiblelefthand to set.
	 */
	public void setVisiblelefthand(boolean visiblelefthand) {
		this.visiblelefthand = visiblelefthand;
	}
	/**
	 * @return Returns the visiblerightfoot.
	 */
	public boolean isVisiblerightfoot() {
		return visiblerightfoot;
	}
	/**
	 * @param visiblerightfoot The visiblerightfoot to set.
	 */
	public void setVisiblerightfoot(boolean visiblerightfoot) {
		this.visiblerightfoot = visiblerightfoot;
	}
	/**
	 * @return Returns the visiblerighthand.
	 */
	public boolean isVisiblerighthand() {
		return visiblerighthand;
	}
	/**
	 * @param visiblerighthand The visiblerighthand to set.
	 */
	public void setVisiblerighthand(boolean visiblerighthand) {
		this.visiblerighthand = visiblerighthand;
	}
	/**
	 * @return Returns the visiblerightshoulder.
	 */
	public boolean isVisiblerightshoulder() {
		return visiblerightshoulder;
	}
	/**
	 * @param visiblerightshoulder The visiblerightshoulder to set.
	 */
	public void setVisiblerightshoulder(boolean visiblerightshoulder) {
		this.visiblerightshoulder = visiblerightshoulder;
	}
	/**
	 * @return Returns the gaze.
	 */
	public int getGaze() {
		return gaze;
	}
	/**
	 * @param gaze The gaze to set.
	 */
	public void setGaze(int gaze) {
		this.gaze = gaze;
	}
	/**
	 * @return Returns the head.
	 */
	public Circle getHead() {
		return head;
	}
	/**
	 * @param head The head to set.
	 */
	public void setHead(Circle head) {
		this.head = head;
	}
	/**
	 * @return Returns the visibleleftshoulder.
	 */
	public boolean isVisibleleftshoulder() {
		return visibleleftshoulder;
	}
	/**
	 * @param visibleleftshoulder The visibleleftshoulder to set.
	 */
	public void setVisibleleftshoulder(boolean visibleleftshoulder) {
		this.visibleleftshoulder = visibleleftshoulder;
	}
}