package xmlcaviargui;
/*
 * CAVIARGUI.java
 *
 * Created on 12 August 2003, 12:18
 *
 */

//package xmlcaviargui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Class used to represent the GUI for the CAVIAR image markup program.
 *
 * @author Donald Nairn
 * @version 1.0
 */

public class CAVIARGUI extends JFrame {
    
    /** Creates new form CAVIARGUI. */
    public CAVIARGUI() {
        initComponents();
	    
    }
    	// GREGOR
	class cpBoxAction extends AbstractAction {
		public cpBoxAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			copyBoxActionPerformed(e);
		}
	}
	class cpBodyAction extends AbstractAction {
		public cpBodyAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			copyBodyActionPerformed(e);
		}
	}	

	class cpTruthsAction extends AbstractAction {
		public cpTruthsAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			copyTruthsActionPerformed(e);
		}
	}
	class nextAction extends AbstractAction {
		public nextAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			nextFrameActionPerformed(e);
		}
	}
	class prevAction extends AbstractAction {
		public prevAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			prevFrameActionPerformed(e);
		}
	}
	class plusIBAction extends AbstractAction {
		public plusIBAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			plusIBAxisButtonActionPerformed(e);
		}
	}
	class minusIBAction extends AbstractAction {
		public minusIBAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			minusIBAxisButtonActionPerformed(e);
		}
	}
	class plusGBAction extends AbstractAction {
		public plusGBAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			plusGBAxisButtonActionPerformed(e);
		}
	}
	class minusGBAction extends AbstractAction {
		public minusGBAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			minusGBAxisButtonActionPerformed(e);
		}
	}


	class KeyDAction extends AbstractAction {
		public KeyDAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			streamPanel.KeyDActionPerformed(e);
			resetIBDisplay();
		}
	}	
	class KeyEAction extends AbstractAction {
		public KeyEAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			copyBodyActionPerformed(e);
		}
	}		 
	class KeyZAction extends AbstractAction {
		public KeyZAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			int index=streamPanel.KeyZActionPerformed(e);
			bodyComboBox.setSelectedIndex(index-1);
			resetIBDisplay();
		}
	}		
	class KeyAAction extends AbstractAction {
		public KeyAAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			streamPanel.KeyAActionPerformed(e,getBodyIncValue());
		}
	}
	class KeySAction extends AbstractAction {
		public KeySAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			streamPanel.KeySActionPerformed(e,getBodyIncValue());
		}
	}		
	class KeyXAction extends AbstractAction {
		public KeyXAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			boolean deleted=streamPanel.KeyXActionPerformed(e);
			resetIBDisplay();
		}
	}	
	class KeyCAction extends AbstractAction {
		public KeyCAction(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
//			streamPanel.KeyCActionPerformed(e);
//			
			if (bodyCheckBox.isSelected())
				bodyCheckBox.setSelected(false);
			else 
				bodyCheckBox.setSelected(true);
			bodyCheckBoxActionPerformed(e);

		}
	}	
		
	private boolean isBoxDrawinSingleBoxSelected(){
		boolean boxdraw=false;
		SingleBox single=streamPanel.getSingleBoxSelected();
		if (streamPanel.isASingleBoxSelected()){
			if (single!=null){
				if (single.getBoxDrawn()){
					boxdraw=true;
				}else{
					JOptionPane.showMessageDialog(null,"Box not drawn for current single box",
									  "Warning",
									  JOptionPane.WARNING_MESSAGE);				
				}
			}else{
				JOptionPane.showMessageDialog(null,"Current single box is not set, draw the box first",
								  "Warning",
								  JOptionPane.WARNING_MESSAGE);						
			}
		}else{
			JOptionPane.showMessageDialog(null,"Current selected box is a group box",
							  "Warning",
							  JOptionPane.WARNING_MESSAGE);				
		}
		return boxdraw;					
	}

	private void bodyComboBoxActionPerformed(ActionEvent e) {
		int index=bodyComboBox.getSelectedIndex();
	    switch(index){
	    	case BODY_BOX:actionSelectionBodyPart(e,1);break;	
			case BODY_HEAD:actionSelectionBodyPart(e,2);break;	
			case BODY_GAZE:actionSelectionBodyPart(e,3);break;
			case BODY_R_SHOULDER:actionSelectionBodyPart(e,4);break;	
			case BODY_L_SHOULDER:actionSelectionBodyPart(e,5);break;	
			case BODY_R_HAND:actionSelectionBodyPart(e,6);break;	
			case BODY_L_HAND:actionSelectionBodyPart(e,7);break;	
			case BODY_R_FOOT:actionSelectionBodyPart(e,8);break;	
			case BODY_L_FOOT:actionSelectionBodyPart(e,9);break;	
	    }
	    resetIBDisplay();
	    this.requestFocus();
	}

//	protected static final int BODY_BOX=0,BODY_HEAD=1,BODY_R_SHOULDER=2,BODY_L_SHOULDER=3,BODY_R_HAND=4,BODY_L_HAND=5,BODY_R_FOOT=6,BODY_L_FOOT=7;
	private void actionSelectionBodyPart(ActionEvent e,int key){
		if (key==1){
			streamPanel.Key1ActionPerformed(e);
			resetIBDisplay();			
		}else{
			if (isBoxDrawinSingleBoxSelected()){			
				switch (key){
					case 2:streamPanel.Key2ActionPerformed(e);break;
					case 3:streamPanel.Key3ActionPerformed(e);break;
					case 4:streamPanel.Key4ActionPerformed(e);break;
					case 5:streamPanel.Key5ActionPerformed(e);break;
					case 6:streamPanel.Key6ActionPerformed(e);break;
					case 7:streamPanel.Key7ActionPerformed(e);break;
					case 8:streamPanel.Key8ActionPerformed(e);break;
					case 9:streamPanel.Key9ActionPerformed(e);break;
				}
				resetIBDisplay();
				streamPanel.drawBody(false);
			}
		}
	}

	class Key1Action extends AbstractAction {
		public Key1Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,1);
		}
	}	
	class Key2Action extends AbstractAction {
		public Key2Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,2);
		}
	}
	class Key3Action extends AbstractAction {
		public Key3Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,3);
		}
	}
	class Key4Action extends AbstractAction {
		public Key4Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,4);			
		}
	}
	class Key5Action extends AbstractAction {
		public Key5Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,5);
		}
	}
	class Key6Action extends AbstractAction {
		public Key6Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,6);			
		}
	}
	class Key7Action extends AbstractAction {
		public Key7Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,7);
		}
	}
	class Key8Action extends AbstractAction {
		public Key8Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,8);
		}
	}
	class Key9Action extends AbstractAction {
		public Key9Action(String name) {
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			actionSelectionBodyPart(e,9);
		}
	}	

	// END GREGOR

    /** This method is called from within the constructor to
     * initialize the form.
     * 
     * Each JButton, JTextField, etc is set to be a height of 30 pixels,
     * this must be edited if a new JButton, JTextField, etc is to be added
     *
     * CAVIARGUI objects are split into 4 JPanels, streamPanel which is
     * an ImagePanel, and is an extension of JPanel is used to represent the
     * the images on the screen, the remainder of the JPanels represent the
     * Individual (Single) Box options for the current frame, the Group Box 
     * options for the current frame and the file options for the annotations done thus far.
     * The Panel is split up accordingly by using a 1 x 4 GridBagLayout,
     * with the relevant contraints used to restrict the position of the JPanels
     * on the JFrame
     */
    private void initComponents() {
        
	GridBagConstraints gridBagConstraints;

	int iBPanelHeight, iBPanelRows, 
	    gBPanelHeight, gBPanelRows, 
	    filePanelHeight, filePanelRows;
	
	// image panel
	streamPanel = new ImagePanel(this);
        
	// individual box panel
	iBPanel = new JPanel();
        iBLabel = new JLabel();
        iBOptions = new JComboBox();
	iBDeleteButton = new JButton();
	axisLabel = new JLabel();
        axisTextField = new JTextField();
	updateIBAxisPanel = new JPanel();
	plusAxisButton = new JButton();
	minusAxisButton = new JButton();
	iBADLabel = new JLabel();
        appearCheckBox = new JCheckBox();
        disappearCheckBox = new JCheckBox();
	occludedCheckBox = new JCheckBox();
	iBActiveLabel = new JLabel();
	movementComboBox = new JComboBox();
	indRoles = new JLabel();
     iRolesComboBox = new JComboBox();
     iSitComboBox = new JComboBox();
     iSceComboBox = new JComboBox();
	situationsLabel = new JLabel();
	scenariosLabel = new JLabel();
	eventsLabel = new JLabel();
	personImmobileCheckBox = new JCheckBox();

	// group box panel
        gBPanel = new JPanel();
        gBLabel = new JLabel();
        gBOptions = new JComboBox();
	gBDeleteButton = new JButton();
	axisGBLabel = new JLabel();
	axisGBTextField = new JTextField();
	updateGBAxisPanel = new JPanel();
	plusGBAxisButton = new JButton();
	minusGBAxisButton = new JButton();
	gBIBLabel = new JLabel();
	gBIBTextField = new JTextField();
	gBIBSelectedLabel = new JLabel();
	gBIBDisplaySelected = new JLabel();
	gBIBText = "Selected Ind Boxes\n:";
	gBIBUpdateText = "";
	gBADLabel = new JLabel();
	gAppearCheckBox = new JCheckBox();
        gDisappearCheckBox = new JCheckBox();
	gBMovementLabel = new JLabel();
	gMovementComboBox = new JComboBox();
	groupRoles = new JLabel();
	gSituationsLabel = new JLabel();
	gScenarioLabel = new JLabel();
	gEventsLabel = new JLabel();
	fightStartCheckBox = new JCheckBox();
	fightEndCheckBox = new JCheckBox();
	fightLeftVictimCheckBox = new JCheckBox();
	
	gRolComboBox = new JComboBox();
	gSitComboBox = new JComboBox();
	gSceComboBox = new JComboBox();
	        
	// file options panel
        fileButtonPanel = new JPanel();
	blank3 = new JLabel();
	blank4 = new JLabel();
	blank5 = new JLabel();
	blank6 = new JLabel();
	blank7 = new JLabel();
        fileOptionsLabel = new JLabel();
	loadFile = new JButton();
        saveFileAs = new JButton();
        saveFile = new JButton();
	loadNewSeq = new JButton();
	resetAll = new JButton();
	jumpToFrame = new JButton();
        resetFrame = new JButton();
	copyToNext = new JButton();
        nextFrame = new JButton();
    copyBody = new JButton();
	copyBox = new JButton();
	copyTruths = new JButton();
	copyToPrev = new JButton();
        prevFrame = new JButton();
	play = new JButton();
	exitFrame = new JButton();
	performCheck = new JCheckBox();

	// required to set space between buttons, textfields, etc
	// would only have 1 but Java doesn't allow the same
	// object to be placed on different panels, frames, etc
	blank3.setText("\t");
	blank4.setText("\t");
	blank5.setText("\t");
	blank6.setText("\t");
	blank7.setText("\t");
	
	GridBagLayout gridBag = new GridBagLayout();
        getContentPane().setLayout(gridBag);
	// set size to fit all panels
	setSize((WIDTH*2)+445,900);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                exitForm(evt);
            }
        });

	streamPanel.setMinimumSize(new Dimension((WIDTH*2), 900));
        streamPanel.setPreferredSize(new Dimension((WIDTH*2), 900));
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.gridheight = 5;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.anchor = GridBagConstraints.NORTH;
        getContentPane().add(streamPanel, gridBagConstraints);

	iBPanelRows = 42;
	iBPanelHeight = 25 * iBPanelRows;
      
	iBPanel.setLayout(new GridLayout(iBPanelRows, 1));

        iBPanel.setMinimumSize(new Dimension(130, iBPanelHeight));
        iBPanel.setPreferredSize(new Dimension(130, iBPanelHeight));
        
	iBLabel.setText("IND BOX OPTIONS");
        iBLabel.setToolTipText("Individual box options");
        iBPanel.add(iBLabel);

        iBOptions.setMaximumRowCount(FrameData.SINGLE_BOXES);
	String[] iModelString = new String[FrameData.SINGLE_BOXES];
	for (int i = 0; i < FrameData.SINGLE_BOXES; i++) {
	    iModelString[i] = "Ind Box "+i;
	}
        iBOptions.setModel(new DefaultComboBoxModel(iModelString));
	iBOptions.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                iBOptionsActionPerformed(evt);
            }
        });	
	
        iBPanel.add(iBOptions);

	iBDeleteButton.setText("DELETE BOX");
	iBDeleteButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                iBDeleteButtonActionPerformed(evt);
            }
        });

	iBPanel.add(iBDeleteButton);

	axisLabel.setText("Axis");
        iBPanel.add(axisLabel);

        axisTextField.setText(String.valueOf(streamPanel.getIBAxis(iBSelected)));
        axisTextField.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                axisTextFieldActionPerformed(evt);
            }
        });

        iBPanel.add(axisTextField);

	plusAxisButton.setMinimumSize(new Dimension(45,20));
	plusAxisButton.setPreferredSize(new Dimension(45,20));
	plusIBAction = new plusIBAction("+");
	plusAxisButton.setAction(plusIBAction);
	plusAxisButton.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("EQUALS"), "plusIB");
	plusAxisButton.getActionMap().put("plusIB", plusIBAction);
	updateIBAxisPanel.add(plusAxisButton);

	minusAxisButton.setMinimumSize(new Dimension(45,20));
	minusAxisButton.setPreferredSize(new Dimension(45,20));
	minusIBAction = new minusIBAction("-");
	minusAxisButton.setAction(minusIBAction);
	minusAxisButton.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("MINUS"), "minusIB");
	minusAxisButton.getActionMap().put("minusIB", minusIBAction);


	updateIBAxisPanel.add(minusAxisButton);

	iBPanel.add(updateIBAxisPanel);

	iBADLabel.setText("Appearance");
	iBPanel.add(iBADLabel);

        appearCheckBox.setText("Appear");
	appearCheckBox.setForeground(Color.RED);
	appearCheckBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    appearCheckBoxActionPerformed(evt);
		}
	    });
	
        iBPanel.add(appearCheckBox);

        disappearCheckBox.setText("Disappear");
	disappearCheckBox.setForeground(Color.RED);
        disappearCheckBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    disappearCheckBoxActionPerformed(evt);
		}
	    });
	
        iBPanel.add(disappearCheckBox);
	
	occludedCheckBox.setText("Occluded");
	occludedCheckBox.setForeground(Color.RED);
	occludedCheckBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    occludedCheckBoxActionPerformed(evt);
		}
	    });

	iBPanel.add(occludedCheckBox);

	iBActiveLabel.setText("Ind Movements");
	iBPanel.add(iBActiveLabel);

	movementComboBox.setMaximumRowCount(SingleBox.MOVEMENT_LENGTH);
	movementComboBox.setForeground(Color.BLUE);
	movementComboBox.setModel(new DefaultComboBoxModel(new String[] {"Unset", "Inactive", "Active", "Walking", "Running" } ));
	movementComboBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    movementComboBoxActionPerformed(evt);
		}
	    });	
	
	iBPanel.add(movementComboBox);
	
	indRoles.setText("Ind Roles");
	iBPanel.add(indRoles);

	iRolesComboBox.setMaximumRowCount(SingleBox.ROLE_LENGTH);
	iRolesComboBox.setForeground(Color.BLUE);
	iRolesComboBox.setModel(new DefaultComboBoxModel(new String[] {" unset", " browser"," walker"," fighter"," left victim"," left object"} ));
	iRolesComboBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		   iRolesComboBoxActionPerformed(evt);
		}
	    });	
	
	iBPanel.add(iRolesComboBox);

	situationsLabel.setText("Ind Situations");
	iBPanel.add(situationsLabel);

	iSitComboBox.setMaximumRowCount(SingleBox.SIT_LENGTH);
	iSitComboBox.setForeground(Color.BLUE);
	iSitComboBox.setModel(new DefaultComboBoxModel(new String[] {" unset", " moving"," inactive"," browsing"," shop enter"," shop exit"} ));
	iSitComboBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		   iSitComboBoxActionPerformed(evt);
		}
	    });	
	
	iBPanel.add(iSitComboBox);

	scenariosLabel.setText("Ind Context");
	iBPanel.add(scenariosLabel);

	iSceComboBox.setMaximumRowCount(SingleBox.SCE_LENGTH);
	iSceComboBox.setForeground(Color.BLUE);
	iSceComboBox.setModel(new DefaultComboBoxModel(new String[] {" unset", " browsing"," immobile"," walking"," drop down"," window shop"," shop enter"," shop exit"," shop reenter"} ));
	iSceComboBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		   iSceComboBoxActionPerformed(evt);
		}
	    });	
	
	iBPanel.add(iSceComboBox);

	eventsLabel.setText("Ind Events");
	iBPanel.add(eventsLabel);

	personImmobileCheckBox.setText("Immobile");
	personImmobileCheckBox.setForeground(PURPLE);
        personImmobileCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                personImmobileCheckBoxActionPerformed(evt);
            }
        });

	iBPanel.add(personImmobileCheckBox);
	
	bodyLabel= new JLabel("Body");
	iBPanel.add(bodyLabel);
	
	bodyStatusLabel=new JLabel("");
	iBPanel.add(bodyStatusLabel);
	
	bodyComboBox = new JComboBox();
	bodyComboBox.setMaximumRowCount(8);
	bodyComboBox.setForeground(Color.BLUE);
	bodyComboBox.setModel(new DefaultComboBoxModel(new String[] {"Box","Head","Gaze","Right Shoulder","Left Shoulder",
												   "Right hand","Left hand","Right foot","Left foot"} ));
												   

	bodyComboBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		   bodyComboBoxActionPerformed(evt);
		}
		});	
	
	iBPanel.add(bodyComboBox);
		
	bodyCheckBox = new JCheckBox("Occluded");	
	bodyCheckBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			bodyCheckBoxActionPerformed(evt);
		}
		});	
	iBPanel.add(bodyCheckBox);
	
	bodyIncLabel = new JLabel("Increment value");
	iBPanel.add(bodyIncLabel);
	
	bodyIncTextField = new JTextField("1");
	iBPanel.add(bodyIncTextField);
	
	bodyDispLabel= new JLabel("Body display");
	iBPanel.add(bodyDispLabel);
	
	bodyselBodyLabels= new JCheckBox("Labels Sel. Box");
	bodyselBodyLabels.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			bodyselActionPerformed(evt);
		}
		});	
	iBPanel.add(bodyselBodyLabels);
	
	bodyDisplayAll= new JCheckBox("All Bodies");
	bodyDisplayAll.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			bodyDispAllActionPerformed(evt);
		}
		});		
	iBPanel.add(bodyDisplayAll);

	bodyDisplayAllLabels= new JCheckBox("label All Boxes");
	bodyDisplayAllLabels.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			bodyDispAllLabelsActionPerformed(evt);
		}
		});		
	iBPanel.add(bodyDisplayAllLabels);
	
	showBoxNames= new JCheckBox("Show Box Names");
	showBoxNames.setSelected(true);
	showBoxNames.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			showBoxNamesActionPerformed(evt);
		}
		});	
	iBPanel.add(showBoxNames);
	

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.gridheight = 5;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.anchor = GridBagConstraints.NORTH;
        getContentPane().add(iBPanel, gridBagConstraints);

	gBPanelRows = 38;
	gBPanelHeight = gBPanelRows * 25;

        gBPanel.setLayout(new GridLayout(gBPanelRows, 1));

	gBPanel.setMinimumSize(new Dimension(135, gBPanelHeight));
	gBPanel.setPreferredSize(new Dimension(135, gBPanelHeight));

        gBLabel.setText("GROUP BOX OPTIONS");
        gBLabel.setToolTipText("Group box options");
        gBPanel.add(gBLabel);

        gBOptions.setMaximumRowCount(FrameData.GROUP_BOXES);
	String[] gModelString = new String[FrameData.GROUP_BOXES];
	for (int i = 0; i < FrameData.GROUP_BOXES; i++) {
	    gModelString[i] = "Group Box "+i;
	}
	gBOptions.setModel(new DefaultComboBoxModel(gModelString));
        gBOptions.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                gBOptionsActionPerformed(evt);
            }
        });

        gBPanel.add(gBOptions);

	gBDeleteButton.setText("DELETE BOX");
	gBDeleteButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    gBDeleteButtonActionPerformed(evt);
		}
	    });
	
	gBPanel.add(gBDeleteButton);
	
	axisGBLabel.setText("Axis");
        gBPanel.add(axisGBLabel);

	axisGBTextField.setText(String.valueOf(streamPanel.getGBAxis(gBSelected)));
	axisGBTextField.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    axisGBTextFieldActionPerformed(evt);
		}
	    });
	

        gBPanel.add(axisGBTextField);

	plusGBAxisButton.setMinimumSize(new Dimension(45,20));
	plusGBAxisButton.setPreferredSize(new Dimension(45,20));

	plusGBAction = new plusGBAction("+");
	plusGBAxisButton.setAction(plusGBAction);
	plusGBAxisButton.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("control EQUALS"), "plusGB");
	plusGBAxisButton.getActionMap().put("plusGB", plusGBAction);

	updateGBAxisPanel.add(plusGBAxisButton);

	minusGBAxisButton.setMinimumSize(new Dimension(45,20));
	minusGBAxisButton.setPreferredSize(new Dimension(45,20));

	minusGBAction = new minusGBAction("-");
	minusGBAxisButton.setAction(minusGBAction);
	minusGBAxisButton.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("control MINUS"), "minusGB");
	minusGBAxisButton.getActionMap().put("minusGB", minusGBAction);


	updateGBAxisPanel.add(minusGBAxisButton);

    	gBPanel.add(updateGBAxisPanel);

	gBIBLabel.setText("Include Ind Boxes");

	gBIBUpdateText = getStringRep();

	gBIBTextField.setText(gBIBUpdateText);
	gBIBTextField.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    gBIBTextFieldActionPerformed(evt);
		}
	    });
	


	gBIBSelectedLabel.setText("Selected Ind Boxes:\n");
	

	gBIBDisplaySelected.setText(gBIBUpdateText);
	

	gBADLabel.setText("Appearance");
	gBPanel.add(gBADLabel);

	gAppearCheckBox.setText("Appear");
	gAppearCheckBox.setForeground(Color.RED);
        gAppearCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                gAppearCheckBoxActionPerformed(evt);
            }
        });

        gBPanel.add(gAppearCheckBox);

        gDisappearCheckBox.setText("Disappear");
	gDisappearCheckBox.setForeground(Color.RED);
        gDisappearCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                gDisappearCheckBoxActionPerformed(evt);
            }
        });

        gBPanel.add(gDisappearCheckBox);

	gBPanel.add(blank7);

	gBMovementLabel.setText("Group Movements");
	gBPanel.add(gBMovementLabel);

	
	gMovementComboBox.setMaximumRowCount(GroupBox.MOVEMENT_LENGTH);
	gMovementComboBox.setForeground(Color.BLUE);
	gMovementComboBox.setModel(new DefaultComboBoxModel(new String[] {"Unset",  "Inactive", "Active", "Movement" } ));
	gMovementComboBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                gMovementComboBoxActionPerformed(evt);
            }
        });

	gBPanel.add(gMovementComboBox);

	groupRoles.setText("Group Roles");
	gBPanel.add(groupRoles);
	
	gRolComboBox.setMaximumRowCount(GroupBox.ROLE_LENGTH);
	gRolComboBox.setForeground(Color.BLUE);
	gRolComboBox.setModel(new DefaultComboBoxModel(new String[] {" unset", " fighters"," browsers"," meeters"," walkers"} ));
	gRolComboBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                gRolComboBoxActionPerformed(evt);
            }
        });

	gBPanel.add(gRolComboBox);	


	gSituationsLabel.setText("Group Situations");
	gBPanel.add(gSituationsLabel);

	gSitComboBox.setMaximumRowCount(GroupBox.SIT_LENGTH);
	gSitComboBox.setForeground(Color.BLUE);
	gSitComboBox.setModel(new DefaultComboBoxModel(new String[] {" unset", " browsing"," fighting"," moving"," joining"," interact"," splitting"," inactive"," shop enter"," shop exit"," leaving"," object left"} ));
	gSitComboBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                gSitComboBoxActionPerformed(evt);
            }
        });

	gBPanel.add(gSitComboBox);	


	gScenarioLabel.setText("Group Context");
	gBPanel.add(gScenarioLabel);
	

	gSceComboBox.setMaximumRowCount(GroupBox.SCE_LENGTH);
	gSceComboBox.setForeground(Color.BLUE);
	gSceComboBox.setModel(new DefaultComboBoxModel(new String[] { " unset", " fighting"," walking"," meeting"," window shop"," shop enter"," shop exit"," shop reenter"," leaving object"} ));
	gSceComboBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                gSceComboBoxActionPerformed(evt);
            }
        });

	gBPanel.add(gSceComboBox);	

	gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.gridheight = 5;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.anchor = GridBagConstraints.NORTH;
        getContentPane().add(gBPanel, gridBagConstraints);

	filePanelRows = 25;
	filePanelHeight = filePanelRows * 25;

        fileButtonPanel.setLayout(new GridLayout(filePanelRows, 1));

        fileButtonPanel.setMinimumSize(new Dimension(145, filePanelHeight));
        fileButtonPanel.setPreferredSize(new Dimension(145, filePanelHeight));
        fileOptionsLabel.setText("FILE OPTIONS");
        fileOptionsLabel.setToolTipText("File options");
        fileButtonPanel.add(fileOptionsLabel);

	loadNewSeq.setText("New JPG Seq");
	loadNewSeq.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                loadNewSeqActionPerformed(evt);
            }
        });

	fileButtonPanel.add(loadNewSeq);

        loadFile.setText("Load Data File");
        loadFile.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                loadFileActionPerformed(evt);
            }
        });

        fileButtonPanel.add(loadFile);

	saveFile.setText("Save Data");
        saveFile.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                saveFileActionPerformed(evt);
            }
        });

        fileButtonPanel.add(saveFile); 

        saveFileAs.setText("Save Data As");
        saveFileAs.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                saveFileAsActionPerformed(evt);            }
        });

        fileButtonPanel.add(saveFileAs);   

	performCheck.setText("Check Consistency");
        performCheck.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                performCheckActionPerformed(evt);
            }
        });
	
	fileButtonPanel.add(performCheck);
	//fileButtonPanel.add(blank3);

	resetAll.setText("Reset All");
        resetAll.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                resetAllActionPerformed(evt);
            }
        });

	fileButtonPanel.add(resetAll);

        resetFrame.setText("Reset Frame");
        resetFrame.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                resetFrameActionPerformed(evt);
            }
        });

        fileButtonPanel.add(resetFrame);

	copyToNext.setText("Copy to Next");
        copyToNext.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                copyToNextActionPerformed(evt);
            }
        });

	fileButtonPanel.add(copyToNext);

/*        nextFrame.setText("Next Frame");
        nextFrame.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                nextFrameActionPerformed(evt);
            }
        });*/
	//GREGOR

	
//insertjose
	
	keyDAction = new KeyDAction("d");
	nextFrame.setAction(keyDAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke(KeyEvent.VK_D,0), "keyDAction");
	nextFrame.getActionMap().put("keyDAction", keyDAction);	

	key1Action = new Key1Action("1");
	nextFrame.setAction(key1Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('1'), "key1Action");
	nextFrame.getActionMap().put("key1Action", key1Action);	
	
	key2Action = new Key2Action("2");
	nextFrame.setAction(key2Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('2'), "key2Action");
	nextFrame.getActionMap().put("key2Action", key2Action);	
	
	key3Action = new Key3Action("3");
	nextFrame.setAction(key3Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('3'), "key3Action");
	nextFrame.getActionMap().put("key3Action", key3Action);	
	
	key4Action = new Key4Action("4");
	nextFrame.setAction(key4Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('4'), "key4Action");
	nextFrame.getActionMap().put("key4Action", key4Action);	
	
	key5Action = new Key5Action("5");
	nextFrame.setAction(key5Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('5'), "key5Action");
	nextFrame.getActionMap().put("key5Action", key5Action);					

	key6Action = new Key6Action("6");
	nextFrame.setAction(key6Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('6'), "key6Action");
	nextFrame.getActionMap().put("key6Action", key6Action);	
	
	key7Action = new Key7Action("7");
	nextFrame.setAction(key7Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('7'), "key7Action");
	nextFrame.getActionMap().put("key7Action", key7Action);		
	
	key8Action = new Key8Action("8");
	nextFrame.setAction(key8Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('8'), "key8Action");
	nextFrame.getActionMap().put("key8Action", key8Action);	

	key9Action = new Key9Action("9");
	nextFrame.setAction(key9Action);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('9'), "key9Action");
	nextFrame.getActionMap().put("key9Action", key9Action);

	keyEAction = new KeyEAction("e");
	nextFrame.setAction(keyEAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('e'), "keyEAction");
	nextFrame.getActionMap().put("keyEAction", keyEAction);	
	
	keyZAction = new KeyZAction("z");
	nextFrame.setAction(keyZAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('z'), "keyZAction");
	nextFrame.getActionMap().put("keyZAction", keyZAction);	
	
	keyAAction = new KeyAAction("a");
	nextFrame.setAction(keyAAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('a'), "keyAAction");
	nextFrame.getActionMap().put("keyAAction", keyAAction);	
	
	keySAction = new KeySAction("s");
	nextFrame.setAction(keySAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('s'), "keySAction");
	nextFrame.getActionMap().put("keySAction", keySAction);	
	
	keyXAction = new KeyXAction("x");
	nextFrame.setAction(keyXAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('x'), "keyXAction");
	nextFrame.getActionMap().put("keyXAction", keyXAction);	
	
	keyCAction = new KeyCAction("c");
	nextFrame.setAction(keyCAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('c'), "keyCAction");
	nextFrame.getActionMap().put("keyCAction", keyCAction);	

	nextAction = new nextAction("Next Frame");
	nextFrame.setAction(nextAction);
	nextFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('n'), "NextFrame");
	nextFrame.getActionMap().put("NextFrame", nextAction);
	//END GREGOR


        fileButtonPanel.add(nextFrame);

	copyBodyAction = new cpBodyAction("Copy Body Next");
	copyBody.setAction(copyBodyAction);
	copyBody.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('e'), "copyBoxNext");
	copyBody.getActionMap().put("copyBodyNext", copyBodyAction);        
	fileButtonPanel.add(copyBody);  

	//copyBox.setText("Copy Box Next");
       /* copyBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                copyBoxActionPerformed(evt);
            }
        });*/
	//GREGOR
	copyBoxAction = new cpBoxAction("Copy Box Next");
	copyBox.setAction(copyBoxAction);
	copyBox.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('b'), "copyBoxNext");
	copyBox.getActionMap().put("copyBoxNext", copyBoxAction);
	//END GREGOR

        fileButtonPanel.add(copyBox);

/*	copyTruths.setText("Copy Truths Next");
        copyTruths.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                copyTruthsActionPerformed(evt);
            }
        });*/
	//GREGOR
	copyTruthsAction = new cpTruthsAction("Copy Truths Next");
	copyTruths.setAction(copyTruthsAction);
	copyTruths.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('t'), "copyTruthsNext");
	copyTruths.getActionMap().put("copyTruthsNext", copyTruthsAction);
	//END GREGOR

        fileButtonPanel.add(copyTruths);

	copyToPrev.setText("Copy to Prev");
        copyToPrev.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                copyToPrevActionPerformed(evt);
            }
        });

	fileButtonPanel.add(copyToPrev);

/*        prevFrame.setText("Prev Frame");
        prevFrame.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                prevFrameActionPerformed(evt);
            }
        });*/
	//GREGOR
	prevAction = new prevAction("Prev Frame");
	prevFrame.setAction(prevAction);
	prevFrame.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('p'), "PrevFrame");
	prevFrame.getActionMap().put("PrevFrame", prevAction);
	//END GREGOR

        fileButtonPanel.add(prevFrame);

	jumpToFrame.setText("Jump to Frame");
        jumpToFrame.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                jumpToFrameActionPerformed(evt);
            }
        });

	fileButtonPanel.add(jumpToFrame);

	fileButtonPanel.add(blank4);

	play.setText("Play");
	play.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                playActionPerformed(evt);
            }
        });

	fileButtonPanel.add(play);

	fileButtonPanel.add(blank5);

        exitFrame.setText("Exit");
        exitFrame.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                exitFrameActionPerformed(evt);
            }
        });
   fileButtonPanel.add(exitFrame);
  	fileButtonPanel.add(blank6);
	
	gEventsLabel.setText("Group Events");
	gBPanel.add(gEventsLabel);

	fightStartCheckBox.setText("Fight Start");
	fightStartCheckBox.setForeground(PURPLE);
        fightStartCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                fightStartCheckBoxActionPerformed(evt);
            }
        });

	gBPanel.add(fightStartCheckBox);

	fightEndCheckBox.setText("Fight End");
	fightEndCheckBox.setForeground(PURPLE);
        fightEndCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                fightEndCheckBoxActionPerformed(evt);
            }
        });

	gBPanel.add(fightEndCheckBox);

	fightLeftVictimCheckBox.setText("Left Victim");
	fightLeftVictimCheckBox.setForeground(PURPLE);
        fightLeftVictimCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                fightLeftVictimCheckBoxActionPerformed(evt);
            }
        });

	gBPanel.add(fightLeftVictimCheckBox);
	  
	gBPanel.add(gBIBLabel);
        gBPanel.add(gBIBTextField);
	gBPanel.add(gBIBSelectedLabel);
	gBPanel.add(gBIBDisplaySelected);
        
	gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.gridheight = 5;
        gridBagConstraints.ipadx = 5;
        gridBagConstraints.ipady = 5;
        gridBagConstraints.anchor = GridBagConstraints.NORTH;
        getContentPane().add(fileButtonPanel, gridBagConstraints);
    }

    /* FOLLWOING METHODS ARE IN NO SPECIFIC ORDER UNFORTUNATELY! */
   
    /**
     * Returns the string representation of the selected single
     * boxes
     */
    private String getStringRep() {
	String display = "";
	boolean[] gBIBSelected = streamPanel.getGBIBoxes(gBSelected);
	for (int i = 0; i < gBIBSelected.length; i++) {
	    if (gBIBSelected[i]) { 
		if (display.equals("")) {
		    display = ""+i;
		} else {
		    display = display + "," + i;
		}
	    }
	}
	return display;
    }
    
    private int getBodyIncValue(){
		int number=1;
		try {
			number = Integer.parseInt(this.bodyIncTextField.getText());
		} catch (NumberFormatException nfe) {
			JOptionPane.showMessageDialog(fileButtonPanel,
							  ("Not a number: "+this.bodyIncTextField.getText())+" setting to default=1",
							  "Inc value Warning",
							  JOptionPane.WARNING_MESSAGE);
			this.bodyIncTextField.setText("1");
		}   
		return number;   	
    }

    /** 
     * Play method is used to view all the jpg files in order to give the
     * illusion of a video stream
     */
    private void playActionPerformed(ActionEvent evt) {
	int confirm = JOptionPane.showConfirmDialog(fileButtonPanel,
						    "This will play all frames from the current\n"+
						    "frame to the last one with all the annotations.\n"+
						    "It cannot be stopped once started\n"+
						    "Would you still like to continue?",
						    "Play Warning", JOptionPane.YES_NO_OPTION);
	if (confirm == 0) {  
	    streamPanel.play();
	    resetGBDisplay();
	    resetIBDisplay();
	}
    }
    

    /** 
     * Method used for exiting the program. Checks whether the program
     * has been saved using the flag hasSaved, if not a JOptionPane window 
     * prompts the  user whether they wish to save the changes made so far.
     * If they choose yes a JOPtionPane window asks the user for the file name
     * they wish to save their changes to. The user may cancel here
     */
    private void exitFrameActionPerformed(ActionEvent evt) {
	if (!hasSaved) {
	    // variable yes, yes = 0 no = 1
	    int confirm = JOptionPane.showConfirmDialog(fileButtonPanel,"Annotations to the frames have not been saved\n"+
						"Would you like to save first?",
					      "Save Edited Frames", JOptionPane.YES_NO_OPTION);
	    if (confirm == 0) {
		// bring up save file window
		String s = JOptionPane.showInputDialog(fileButtonPanel,
						       ("Enter file name you wish to save data as:\n"),
						       "Save file",
						       JOptionPane.PLAIN_MESSAGE);
		
		if ((s != null) && (s.length() > 0)) {
		    streamPanel.saveAsFile(s);
		    System.exit(0);
		} else {
		    JOptionPane.showMessageDialog(fileButtonPanel,
						  ("No file name specified"),
						  "Save File Warning",
						  JOptionPane.WARNING_MESSAGE);
		}
	    } else {
		System.exit(0);
	    }
	} else {
	    System.exit(0);
	}
    }

    /** 
     * Simple method that loads the previous frame ignoring all
     * annotations from the previous one, ie if annotations have
     * been done will load them, otherwise loads a blank frameData object
     */
    private void copyToPrevActionPerformed(ActionEvent evt) {
	streamPanel.copyToPrev();
	resetGBDisplay();
	resetIBDisplay();
	hasSaved = false;
    }
    

    
    private void copyBoxActionPerformed(ActionEvent evt) {
	streamPanel.copyBoxNext();
	resetGBDisplay();
	resetIBDisplay();
	hasSaved = false;
    }

    private void copyTruthsActionPerformed(ActionEvent evt) {
	streamPanel.copyTruthsNext();
	resetGBDisplay();
	resetIBDisplay();
	hasSaved = false;
    }

	private void copyBodyActionPerformed(ActionEvent evt) {
	streamPanel.copyBodyNext();
	resetGBDisplay();
	resetIBDisplay();
//	System.out.println("reseting the screen");
	hasSaved = false;
	}

    private void copyToNextActionPerformed(ActionEvent evt) {
	streamPanel.copyToNext();
	resetGBDisplay();
	resetIBDisplay();
	hasSaved = false;
    }

    /** 
     * Simple method that simply loads the next frame in the sequence,
     * setting up the next frame exactly as the previous frame
     * if it has not been annotated already
     */
    private void nextFrameActionPerformed(ActionEvent evt) {
    streamPanel.loadNext();
	resetGBDisplay();
	resetIBDisplay();
	streamPanel.refreshScreen();
    }
    
	/** 
	 * Simple method that simply loads the next frame in the sequence,
	 * setting up the next frame exactly as the prev frame
	 * if it has not been annotated already
	 */
	private void prevFrameActionPerformed(ActionEvent evt) {
	streamPanel.loadPrev();
	resetGBDisplay();
	resetIBDisplay();
	streamPanel.refreshScreen();
	}    


    /** 
     * Resets all the bounding boxes in the current frame. As this could 
     * be annoying if done by asking a JOptionPane yes/no confirm window appears
     * to confirm that this is what the user wants to do
     */
    private void resetFrameActionPerformed(ActionEvent evt) {
	int confirm = JOptionPane.showConfirmDialog(fileButtonPanel,"Are you sure you would like to\n"+
						    "reset all boxes on this frame?",
						    "Reset Frames", JOptionPane.YES_NO_OPTION);
	if (confirm == 0) {
	    streamPanel.resetFrame();
	    resetIBDisplay();
	    resetGBDisplay();
	}
    }

    private void resetAllActionPerformed(ActionEvent evt) {
        int confirm = JOptionPane.showConfirmDialog(fileButtonPanel,"Are you sure you would like to\n"+
						    "reset ALL annotations on ALL frames\n"+
						    "done so far?",
						    "Reset All Frames", JOptionPane.YES_NO_OPTION);
	if (confirm == 0) {
	    streamPanel.resetAll();
	    resetIBDisplay();
	    resetGBDisplay();
	}
    }
    
    private void jumpToFrameActionPerformed(ActionEvent evt) {
        String frameNo = JOptionPane.showInputDialog(fileButtonPanel,
						     ("Enter frame you wish to jump to:"),
						   "Jump to Frame",
						   JOptionPane.PLAIN_MESSAGE);
	    
	if ((frameNo != null) && (frameNo.length() > 0)) {
	    try {
		int number = Integer.parseInt(frameNo);
		streamPanel.jumpToFrame(number);
		resetIBDisplay();
		resetGBDisplay();
	    } catch (NumberFormatException nfe) {
		JOptionPane.showMessageDialog(fileButtonPanel,
					      ("Not a number: "+frameNo),
					      "Jump to Frame Warning",
					      JOptionPane.WARNING_MESSAGE);
	    }
	} else {
	    JOptionPane.showMessageDialog(fileButtonPanel,
					  ("No frame number specified"),
					  "Jump to Frame Warning",
					  JOptionPane.WARNING_MESSAGE);
	}
    }
    
    /** 
     * Method used to load a new initial sequence frame. At present the program
     * is not intended for use with a mid-sequence frame. There are relavent 
     * failsafes to stop the program crashing (hopefully...) but this should not be attempted
     * anyway. Uses the questions 'are there hundreds or thousands of frames in the
     * sequence' to set a hundreds flag in streamPanel, which is essential for the
     * way that class determines the number of the frame to be loaded, ie 0001 or 001.
     * Resets the display once a new image has been loaded
     */
    private void loadNewSeqActionPerformed(ActionEvent evt){
	Object[] options = {"Hundreds", "Thousands", "Cancel"}; 
	int confirm = JOptionPane.showOptionDialog(fileButtonPanel,
						   "IMPORTANT: Are there hundreds of frames\n"+
						   "in the video sequence?\n",
						   "Number of Frames", 
						   JOptionPane.YES_NO_OPTION,
						   JOptionPane.QUESTION_MESSAGE,
						   null,     
						   options,  
						   options[0]);
	boolean loaded = false;
	if (confirm != 2) {
	    String seqName = JOptionPane.showInputDialog(fileButtonPanel,
						   ("Enter jpg sequence name you wish to load:\n"),
						   "Load Sequence",
						   JOptionPane.PLAIN_MESSAGE);
	    
	    if ((seqName != null) && (seqName.length() > 0)) {
		if (confirm == 0) {
		    loaded = streamPanel.loadNewSeq(seqName,true);
		} else { // must be 1 
		    loaded = streamPanel.loadNewSeq(seqName,false);
		}
	    } else {
		JOptionPane.showMessageDialog(null,
					      ("No file name specified"),
					      "Save File Warning",
						  JOptionPane.WARNING_MESSAGE);
	    }
		
	    if (loaded) {
		hasSaved = false;
		saveFileString = "";
		int select = streamPanel.getSelected();
		if (select < FrameData.SINGLE_BOXES) {
		    iBSelected = select;
		    singleSelected = true;
		} else {
		    gBSelected = select - FrameData.SINGLE_BOXES;
		    singleSelected = false;
		}
		
		resetGBDisplay();
		resetIBDisplay();
	    }
	}
    }

    /** 
     * Checks whether a .xml save file has been specified to be saved to.
     * If not will prompt the user and ask for a file name, otherwise it will
     * save file to the currently named data file.
     */
    private void saveFileActionPerformed(ActionEvent evt) {
	if (saveFileString == "") {
	    JOptionPane.showMessageDialog(fileButtonPanel,
					  ("Must Save As for first save to\n"+
					   "specify file name"),
					  "Save File Warning",
					  JOptionPane.WARNING_MESSAGE);
	} else {
	    if (streamPanel.saveAsFile(saveFileString)) {
		hasSaved = true;
	    }
	}
    }

    /**
     * Saves the file using the current file name stored in saveFileString
     */
    private void saveFileAsActionPerformed(ActionEvent evt) {
	
	String fileName = JOptionPane.showInputDialog(fileButtonPanel,
						       ("Enter name of data file you wish to save\n"),
						       "Save file",
						       JOptionPane.PLAIN_MESSAGE);
	    
	if ((fileName != null) && (fileName.length() > 0)) {
	    
	    saveFileString = fileName;
	    if (streamPanel.saveAsFile(saveFileString)) {
		hasSaved = true;
	    }
		    
	} else {
	    JOptionPane.showMessageDialog(fileButtonPanel,
					  ("No file name specified"),
					  "Save File Warning",
					  JOptionPane.WARNING_MESSAGE);
	}
    }
    
    /** 
     * Prompts the user for whether there are hundreds or thousands of frames
     * so that the file name can be correctly worked out by streamPanel,
     * then loads the file into streamPanel and updates the display and
     * the appropriate selected parameters in this CAVIARGUI object
     */
    private void loadFileActionPerformed(ActionEvent evt) {
	/*Object[] options = {"Hundreds", "Thousands", "Cancel"}; 
	int confirm = JOptionPane.showOptionDialog(fileButtonPanel,
						   "IMPORTANT: Are there hundreds of frames\n"+
						   "in the video sequence?\n",
						   "Number of Frames", 
						   JOptionPane.YES_NO_OPTION,
						   JOptionPane.QUESTION_MESSAGE,
						   null,     
						   options,  
						   options[0]);
			
	*/
	boolean loaded = false;
	//if (confirm != 2) {
	    String fileName = JOptionPane.showInputDialog(fileButtonPanel,
							  ("Enter xml file name you wish to load:\n"),
							  "Load file",
							  JOptionPane.PLAIN_MESSAGE);
	    
	    if ((fileName != null) && (fileName.length() > 0)) {
		//if (confirm == 0) {
		loaded = streamPanel.loadFile(fileName/*,true*/);
		//} else if (confirm == 1) {
		//loaded = streamPanel.loadFile(fileName,false);
		//} 
		

		if (loaded) {
		    hasSaved = false;
		    saveFileString = ""; // as must specify diectory now cannot set save file string
		    int select = streamPanel.getSelected();
		    if (select < FrameData.SINGLE_BOXES) {
			iBSelected = select;
			singleSelected = true;
		    } else {
			gBSelected = select - FrameData.SINGLE_BOXES;
			singleSelected = false;
		    }
		    saveFileString = fileName;
		    resetGBDisplay();
		    resetIBDisplay();
		}
	    } else {
		JOptionPane.showMessageDialog(fileButtonPanel,
					      ("No file name specified"),
					      "Save File Warning",
					      JOptionPane.WARNING_MESSAGE);
	    }
	    //}
    }

    private void fightLeftVictimCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBFightVictimLeft(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    //PTC
    private void performCheckActionPerformed(ActionEvent evt){
	streamPanel.setPerformCheck();
    }
    //END PTC
    
    private void fightEndCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBFightEnd(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void fightStartCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBFightStart(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    /*private void leavingScenarioCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBLeaving(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void meetingScenarioCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBMeeting(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void fightingScenarioCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBFighting(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void personLeavingObjectCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBLeftObject(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }*/

    /** 
     * Checks whether it is this group box that is selected
     * using singleSelected, toggles the left behind truth in the selected GroupBox
     * object and then resets the display
     */
    /*private void gLeftBehindCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBLeftBehind(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void inactiveSitCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBGrInactive(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void splitCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBGrSplitting(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void meetCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBGrMeeting(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void interactCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBGrInteracting(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }


    private void movingCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBGrMoving(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }
	
    private void fightingCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBGrFighting(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void walkersCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBWalk(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }*/

    /** 
     * Checks whether it is this group box that is selected
     * using singleSelected, toggles the meet truth in the selected GroupBox
     * object and then resets the display
     */
    /*private void meetersCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBMeet(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }*/

    /** 
     * Checks whether it is this group box that is selected
     * using singleSelected, toggles the fight truth in the selected GroupBox
     * object and then resets the display
     */
    /*private void fightersCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBFight(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }*/
    


    private void gMovementComboBoxActionPerformed(ActionEvent evt) {
	if (programUpdate) ; // do nothing
	else if (singleSelected) {
	    singleSelectedErrorMessage();
	    resetGBDisplay();
	} else {
	    int movement = gMovementComboBox.getSelectedIndex();
	    if (movement == GB_ACTIVE && streamPanel.getGBActive(gBSelected) != true) {
		streamPanel.setGBActive(gBSelected);
	    } else if (movement == GB_INACTIVE && streamPanel.getGBInActive(gBSelected) != true) {
		streamPanel.setGBInActive(gBSelected);
	    } else if (movement == GB_MOVE && streamPanel.getGBMove(gBSelected) != true) {
		streamPanel.setGBMove(gBSelected);
	    } else if (movement == GBNONE_MOV && streamPanel.getGBNoneMov(gBSelected) != true) {
		streamPanel.setGBNoneMov(gBSelected);
	    }
	    hasSaved = false;
	}
	resetGBDisplay();
    }
    
    private void gRolComboBoxActionPerformed(ActionEvent evt) {
//    System.out.println("se dispara group rol");
	if (programUpdate) ; // do nothing
	else if (singleSelected) {
	    singleSelectedErrorMessage();
	    resetGBDisplay();
	} else {
	    int rol = gRolComboBox.getSelectedIndex();
	    if (rol == GBFIGHTERS && streamPanel.getGBFight(gBSelected) != true) {
		streamPanel.setGBFight(gBSelected);
	    } else if (rol == GBBROWSERS && streamPanel.getGBbrowserRole(gBSelected) != true) {
		streamPanel.setGBbrowserRole(gBSelected);
	    } else if (rol == GBMEETERS && streamPanel.getGBMeet(gBSelected) != true) {
		streamPanel.setGBMeet(gBSelected);
	    }  else if (rol == GBWALKERS && streamPanel.getGBWalk(gBSelected) != true) {
		streamPanel.setGBWalk(gBSelected);
	    }  else if (rol == GBNONE_ROL && streamPanel.getGBNoneRol(gBSelected) != true) {
		streamPanel.setGBNoneRol(gBSelected);
	    }

	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void gSitComboBoxActionPerformed(ActionEvent evt) {
//    System.out.println("se dispara group situation");
	if (programUpdate) ; // do nothing
	else if (singleSelected) {
	    singleSelectedErrorMessage();
	    resetGBDisplay();
	} else {
	    int sit = gSitComboBox.getSelectedIndex();
	    if (sit == GBBROWSING_SIT && streamPanel.getGBbrowsingSit(gBSelected) != true) {
		streamPanel.setGBbrowsingSit(gBSelected);
	    } else if (sit == GBFIGHTING_SIT && streamPanel.getGBGrFighting(gBSelected) != true) {
		streamPanel.setGBGrFighting(gBSelected);
	    } else if (sit == GBMOVING_SIT && streamPanel.getGBGrMoving(gBSelected) != true) {
		streamPanel.setGBGrMoving(gBSelected);
	    }  else if (sit == GBMEETING_SIT && streamPanel.getGBGrMeeting(gBSelected) != true) {
		streamPanel.setGBGrMeeting(gBSelected);
	    }  else if (sit == GBINTERACT_SIT && streamPanel.getGBGrInteracting(gBSelected) != true) {
		streamPanel.setGBGrInteracting(gBSelected);
	    }  else if (sit == GBSPLITTING_SIT && streamPanel.getGBGrSplitting(gBSelected) != true) {
		streamPanel.setGBGrSplitting(gBSelected);
	    }  else if (sit == GBINACTIVE_SIT && streamPanel.getGBGrInactive(gBSelected) != true) {
		streamPanel.setGBGrInactive(gBSelected);
	    }  else if (sit == GBSHOPENTER_SIT && streamPanel.getGBshopenterSit(gBSelected) != true) {
		streamPanel.setGBshopenterSit(gBSelected);
	    }  else if (sit == GBSHOPEXIT_SIT && streamPanel.getGBshopexitSit(gBSelected) != true) {
		streamPanel.setGBshopexitSit(gBSelected);
	    }  else if (sit == GBLEAVING_SIT && streamPanel.getGBLeftBehind(gBSelected) != true) {
		streamPanel.setGBLeftBehind(gBSelected);
	    }  else if (sit == GBLEAVINGOBJ_SIT && streamPanel.getGBLeftObject(gBSelected) != true) {
		streamPanel.setGBLeftObject(gBSelected);
	    }  else if (sit == GBNONE_SIT && streamPanel.getGBNoneSit(gBSelected) != true) {
		streamPanel.setGBNoneSit(gBSelected);
	    }
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    private void gSceComboBoxActionPerformed(ActionEvent evt) {
//    System.out.println("se dispara group situation");
	if (programUpdate) ; // do nothing
	else if (singleSelected) {
	    singleSelectedErrorMessage();
	    resetGBDisplay();
	} else {
	    int sce = gSceComboBox.getSelectedIndex();
	    if (sce == GBFIGHTING_SCE && streamPanel.getGBFighting(gBSelected) != true) {
		streamPanel.setGBFighting(gBSelected);
	    } else if (sce == GBWALKING_SCE && streamPanel.getGBwalkingSce(gBSelected) != true) {
		streamPanel.setGBwalkingSce(gBSelected);
	    } else if (sce == GBMEETING_SCE && streamPanel.getGBMeeting(gBSelected) != true) {
		streamPanel.setGBMeeting(gBSelected);
	    }  else if (sce == GBWINDOWSHOP_SCE && streamPanel.getGBwindowshopSce(gBSelected) != true) {
		streamPanel.setGBwindowshopSce(gBSelected);
	    }  else if (sce == GBSHOPENTER_SCE && streamPanel.getGBshopenterSce(gBSelected) != true) {
		streamPanel.setGBshopenterSce(gBSelected);
	    }  else if (sce == GBSHOPEXIT_SCE && streamPanel.getGBshopexitSce(gBSelected) != true) {
		streamPanel.setGBshopexitSce(gBSelected);
	    }  else if (sce == GBSHOPREENTER_SCE && streamPanel.getGBshopreenterSce(gBSelected) != true) {
		streamPanel.setGBshopreenterSce(gBSelected);
	    }  else if (sce == GBLEAVING_SCE && streamPanel.getGBLeaving(gBSelected) != true) {
		streamPanel.setGBLeaving(gBSelected);
	    }  else if (sce == GBNONE_SCE && streamPanel.getGBNoneSce(gBSelected) != true) {
		streamPanel.setGBNoneSce(gBSelected);
	    } 
	    hasSaved = false;
	}
	resetGBDisplay();
    }



    /** 
     * Checks whether it is this group box that is selected
     * using singleSelected, toggles the disappear truth in the selected GroupBox
     * object and then resets the display
     */
    private void gDisappearCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage();
	} else {
	    streamPanel.setGBDisappear(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    /** 
     * Checks whether it is this group box that is selected
     * using singleSelected, toggles the appear truth in the selected GroupBox
     * object and then resets the display
     */
    private void gAppearCheckBoxActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	} else {
	    streamPanel.setGBAppear(gBSelected);
	    hasSaved = false;
	}
	resetGBDisplay();
    }

    /** 
     * Used to update the data structure for the GroupBox object to include
     * the ind boxes included in the text field gBIBTextField
     */
    private void gBIBTextFieldActionPerformed(ActionEvent evt){ 
	if (singleSelected) {
	    singleSelectedErrorMessage();
	    resetGBDisplay();
	} else {
	    try {
		String text =  gBIBTextField.getText();
		String[] boxes = text.split(",");
		for (int i = 0; i < boxes.length; i++) {
		    try {
			int update = Integer.parseInt(boxes[i]);
			if (update >= FrameData.SINGLE_BOXES) {
			    JOptionPane.showMessageDialog(gBPanel,
							  ("Numbers must be in range 0 to "+
							   (FrameData.SINGLE_BOXES-1)+"\n"+update+" outwith this range"),
							  "Invalid Value",
							  JOptionPane.WARNING_MESSAGE);
			    return;
			}
		    } catch (NumberFormatException nfe) {
			JOptionPane.showMessageDialog(gBPanel,
						      (boxes[i]+" not a number"),
						      "Invalid Value",
						      JOptionPane.WARNING_MESSAGE);
		    }
		}
		Rectangle group = streamPanel.getGroupBox(gBSelected);
		
		if (group == null) {
		    JOptionPane.showMessageDialog(gBPanel,
						  ("Group Box "+gBSelected+" is not drawn"),
						  "Invalid Value",
						  JOptionPane.WARNING_MESSAGE);
		    return;
		}
		
		for (int i = 0; i < boxes.length; i++) {
		    int update = Integer.parseInt(boxes[i]);
		    Rectangle single = streamPanel.getSingleBox(update);
		    if (single == null) {
			JOptionPane.showMessageDialog(gBPanel,
						      ("Individual box "+update+" is not yet\n"+
						       "initialised"),
						      "Invalid Value",
						      JOptionPane.WARNING_MESSAGE);
			return;
		    } else {
			if (! (single.getX() >= group.getX() && 
			       (single.getX()+single.getWidth()) <= (group.getX()+group.getWidth()) &&
			       single.getY() >= group.getY() &&
			       (single.getY()+single.getHeight()) <= (group.getY()+group.getHeight()))) {
			    JOptionPane.showMessageDialog(gBPanel,
							  ("Individual Box "+i+" is not fully enclosed\n"+
							   "by Group Box "+gBSelected),
							  "Invalid Value",
							  JOptionPane.WARNING_MESSAGE);
			    return;
			}
		    }
		}
		
		streamPanel.setGBIBoxes(gBSelected,boxes);
		resetGBDisplay();
		
	    } catch (NumberFormatException nfe) {
		JOptionPane.showMessageDialog(gBPanel,
					      ("Must input a list of integers like:\n"+
					       "025 - means ind boxes 0, 2 and 5"),
					      "Invalid Value",
					      JOptionPane.WARNING_MESSAGE);
	    }
	}
    }    

    /** 
     * Checks whether it is this group box that is selected
     * using singleSelected, alters the axis of orientation in the selected GroupBox
     * object and then resets the display (including the image in streamPanel)
     */
    private void axisGBTextFieldActionPerformed(ActionEvent evt) {
	// default set to 90, if there is a number format exception
	// ie a string is entered and not a number then show error 
	// message. if the value is outside 0 to 179, then show error
	// message. if an error message is shown reset to default
	if (singleSelected) {
	    singleSelectedErrorMessage();
	    resetGBDisplay();
	} else {
	    int update = 0;
	    try {
		update = Integer.valueOf(axisGBTextField.getText()).intValue();
	    } catch(NumberFormatException e){
		JOptionPane.showMessageDialog(gBPanel,
					      ("Invalid angle - "+
					       axisGBTextField.getText()+
					       "\nMust be in range 0 to 179"),
					      "Invalid Value",
					      JOptionPane.WARNING_MESSAGE); 
		return;
	    }
	    if (update < 0 || update > 179) {
		JOptionPane.showMessageDialog(gBPanel,
					  ("Invalid angle - "+
					   axisGBTextField.getText()+
					   "\nMust be in range 0 to 179"),
					      "Invalid Value",
					      JOptionPane.WARNING_MESSAGE); 
	    } else {
		streamPanel.setGBAxis(gBSelected,update);
	    }
	    hasSaved = false;
	}
    }

    /** 
     * Used to add 1 degree to the axis of orientation. Could be improved
     * by allowing the user to hold down the button or specfy a greater
     * angle to change the orientation by. Uses same error detection/correction
     * as updateGBAxis
     */
    private void plusGBAxisButtonActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage(); 
	    resetGBDisplay();
	} else {
	    int update = streamPanel.getGBAxis(gBSelected);
	    if (update == 179) {
		streamPanel.setGBAxis(gBSelected,0);
		axisTextField.setText("0");
	    } else {
		streamPanel.setGBAxis(gBSelected,update+1);
		axisGBTextField.setText(String.valueOf(update+1));
	    }
	    hasSaved = false;
	}
    }
    
    /** 
     * Used to take away 1 degree to the axis of orientation. Could be improved
     * by allowing the user to hold down the button or specfy a greater
     * angle to change the orientation by. Uses same error detection/correction
     * as updateGBAxis
     */
    private void minusGBAxisButtonActionPerformed(ActionEvent evt) {
	if (singleSelected) {
	    singleSelectedErrorMessage();
	    resetGBDisplay();
	} else {
	    int update = streamPanel.getGBAxis(gBSelected);
	    if (update == 0) {
		streamPanel.setGBAxis(gBSelected,179);
		axisGBTextField.setText("179");
	    } else {
		streamPanel.setGBAxis(gBSelected,update-1);
		axisGBTextField.setText(String.valueOf(update-1));
	    }
	    hasSaved = false;
	}
    }


    /** 
     * Used to delete the selected GB form the screen. For the same reason as 
     * reset a confirm dialog is shown so that the user does not accidently 
     * delete a box. Does this like reset, but only reseting the datastructure
     * in streamPanel (a FrameData object with a GroupBox param)
     */
    private void gBDeleteButtonActionPerformed(ActionEvent evt) {
	if (streamPanel.isEmptyGroBox(gBSelected)==true){
		deleteEmptyGBoxMessage();
	}
	else if (singleSelected) {
	    singleSelectedErrorMessage(); 
	    resetGBDisplay();
	} else {
		 JFrame aux=new JFrame();
		 JOptionPane option = new JOptionPane();
		 aux.getContentPane().add(option);
		 aux.setVisible(true);
		 aux.setLocation(900,160);
	    int confirm = JOptionPane.showConfirmDialog(aux,"Are you sure you would like to delete\n"+
							"this group box from the annotation?",
							"Delete Box?", JOptionPane.YES_NO_OPTION);
	    if (confirm == 0) {
		streamPanel.deleteGroBox(gBSelected);
		resetGBDisplay();
		hasSaved = false; 
	    }
	    aux.setVisible(false);
	}
    }

    /** 
     * Used to update the gBPanel to reflect changes made to the data
     * structure.
     */
    private void resetGBDisplay() {
	int index = streamPanel.getSelected();
	if (index >= FrameData.SINGLE_BOXES) {
	    gBOptions.setSelectedIndex(index-FrameData.SINGLE_BOXES);
	    gBSelected = index-FrameData.SINGLE_BOXES;
	} 
	axisGBTextField.setText(String.valueOf(streamPanel.getGBAxis(gBSelected)));
	String IBSelected = getStringRep();
	gBIBTextField.setText(IBSelected);
	gBIBDisplaySelected.setText(IBSelected);
	gAppearCheckBox.setSelected(streamPanel.getGBAppear(gBSelected));
	gDisappearCheckBox.setSelected(streamPanel.getGBDisappear(gBSelected));
	programUpdate = true;
	if (streamPanel.getGBActive(gBSelected) == true && gMovementComboBox.getSelectedIndex() != GB_ACTIVE) {
	    gMovementComboBox.setSelectedIndex(GB_ACTIVE);
	} else if (streamPanel.getGBInActive(gBSelected) == true && gMovementComboBox.getSelectedIndex() != GB_INACTIVE) {
	    gMovementComboBox.setSelectedIndex(GB_INACTIVE);
	} else if (streamPanel.getGBMove(gBSelected) == true && gMovementComboBox.getSelectedIndex() != GB_MOVE) {
	    gMovementComboBox.setSelectedIndex(GB_MOVE);
	} else if (streamPanel.getGBNoneMov(gBSelected) == true && gMovementComboBox.getSelectedIndex() != GBNONE_MOV) {
	    gMovementComboBox.setSelectedIndex(GBNONE_MOV);
	}

	if (streamPanel.getGBFight(gBSelected) == true && gRolComboBox.getSelectedIndex() != GBFIGHTERS) {
	    gRolComboBox.setSelectedIndex(GBFIGHTERS);
	} else if (streamPanel.getGBbrowserRole(gBSelected) == true && gRolComboBox.getSelectedIndex() != GBBROWSERS) {
	    gRolComboBox.setSelectedIndex(GBBROWSERS);
	} else if (streamPanel.getGBMeet(gBSelected) == true && gRolComboBox.getSelectedIndex() != GBMEETERS) {
	    gRolComboBox.setSelectedIndex(GBMEETERS);
	} else if (streamPanel.getGBWalk(gBSelected) == true && gRolComboBox.getSelectedIndex() != GBWALKERS) {
	    gRolComboBox.setSelectedIndex(GBWALKERS);
	} else if (streamPanel.getGBNoneRol(gBSelected) == true && gRolComboBox.getSelectedIndex() != GBNONE_ROL) {
	    gRolComboBox.setSelectedIndex(GBNONE_ROL);
	}

	if (streamPanel.getGBbrowsingSit(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBBROWSING_SIT) {
	    gSitComboBox.setSelectedIndex(GBBROWSING_SIT);
	} else if (streamPanel.getGBGrFighting(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBFIGHTING_SIT) {
	    gSitComboBox.setSelectedIndex(GBFIGHTING_SIT);
	} else if (streamPanel.getGBGrMoving(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBMOVING_SIT) {
	    gSitComboBox.setSelectedIndex(GBMOVING_SIT);
	} else if (streamPanel.getGBGrMeeting(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBMEETING_SIT) {
	    gSitComboBox.setSelectedIndex(GBMEETING_SIT);
	} else if (streamPanel.getGBGrInteracting(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBINTERACT_SIT) {
	    gSitComboBox.setSelectedIndex(GBINTERACT_SIT);
	} else if (streamPanel.getGBGrSplitting(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBSPLITTING_SIT) {
	    gSitComboBox.setSelectedIndex(GBSPLITTING_SIT);
	} else if (streamPanel.getGBGrInactive(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBINACTIVE_SIT) {
	    gSitComboBox.setSelectedIndex(GBINACTIVE_SIT);
	}  else if (streamPanel.getGBshopenterSit(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBSHOPENTER_SIT) {
	    gSitComboBox.setSelectedIndex(GBSHOPENTER_SIT);
	}  else if (streamPanel.getGBshopexitSit(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBSHOPEXIT_SIT) {
	    gSitComboBox.setSelectedIndex(GBSHOPEXIT_SIT);
	}  else if (streamPanel.getGBLeftBehind(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBLEAVING_SIT) {
	    gSitComboBox.setSelectedIndex(GBLEAVING_SIT);
	}  else if (streamPanel.getGBLeftObject(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBLEAVINGOBJ_SIT) {
	    gSitComboBox.setSelectedIndex(GBLEAVINGOBJ_SIT);
	}  else if (streamPanel.getGBNoneSit(gBSelected) == true && gSitComboBox.getSelectedIndex() != GBNONE_SIT) {
	    gSitComboBox.setSelectedIndex(GBNONE_SIT);
	}


	if (streamPanel.getGBFighting(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBFIGHTING_SCE) {
	    gSceComboBox.setSelectedIndex(GBFIGHTING_SCE);
	} else if (streamPanel.getGBwalkingSce(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBWALKING_SCE) {
	    gSceComboBox.setSelectedIndex(GBWALKING_SCE);
	} else if (streamPanel.getGBMeeting(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBMEETING_SCE) {
	    gSceComboBox.setSelectedIndex(GBMEETING_SCE);
	} else if (streamPanel.getGBwindowshopSce(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBWINDOWSHOP_SCE) {
	    gSceComboBox.setSelectedIndex(GBWINDOWSHOP_SCE);
	} else if (streamPanel.getGBshopenterSce(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBSHOPENTER_SCE) {
	    gSceComboBox.setSelectedIndex(GBSHOPENTER_SCE);
	} else if (streamPanel.getGBshopexitSce(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBSHOPEXIT_SCE) {
	    gSceComboBox.setSelectedIndex(GBSHOPEXIT_SCE);
	} else if (streamPanel.getGBshopreenterSce(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBSHOPREENTER_SCE) {
	    gSceComboBox.setSelectedIndex(GBSHOPREENTER_SCE);
	}  else if (streamPanel.getGBLeaving(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBLEAVING_SCE) {
	    gSceComboBox.setSelectedIndex(GBLEAVING_SCE);
	}  else if (streamPanel.getGBNoneSce(gBSelected) == true && gSceComboBox.getSelectedIndex() != GBNONE_SCE) {
	    gSceComboBox.setSelectedIndex(GBNONE_SCE);
	} 

	programUpdate = false;	
	fightStartCheckBox.setSelected(streamPanel.getGBFightStart(gBSelected));
	fightEndCheckBox.setSelected(streamPanel.getGBFightEnd(gBSelected));
	fightLeftVictimCheckBox.setSelected(streamPanel.getGBFightVictimLeft(gBSelected));


		
	}
    
    /** 
     * Used for selection of group boxes, must be a number from 1 to 7
     * (temporarily)
     */
    private void gBOptionsActionPerformed(ActionEvent evt) {
        int index = gBOptions.getSelectedIndex();
	streamPanel.setGroupSelected(index);
	gBSelected = index;
	singleSelected = false;
	resetGBDisplay();
	this.requestFocus();
    }

    /** 
     * Used for selection of single boxes, must be a number from 1 to 7
     * (temporarily)
     */
    private void iBOptionsActionPerformed(ActionEvent evt) {
	int index = iBOptions.getSelectedIndex();
	streamPanel.setSingleSelected(index);
	iBSelected = index;
	singleSelected = true;
	resetIBDisplay();
	this.requestFocus();
    }

	public boolean singleBoxExistinGroupBox(int single){
	return streamPanel.singleBoxinGroupBox(single);
	}
	
    /** 
     * Used to delete the selected IB form the screen. For the same reason as 
     * reset a confirm dialog is shown so that the user does not accidently 
     * delete a box. Does this like reset, but only reseting the datastructure
     * in streamPanel (a FrameData object with a SingleBox param)
     */
    private void iBDeleteButtonActionPerformed(ActionEvent evt) {
	if (streamPanel.isEmptySingleBox(iBSelected)==true){
		deleteEmptyIBoxMessage();	
	}
	else if (!singleSelected) {
	    groupSelectedErrorMessage(); 
	    resetIBDisplay();
	}else if (singleBoxExistinGroupBox(iBSelected)==true){
		deleteIBox_inGBoxMessage();
	}
	else {
		 //iBPanel.setLocation(100,100);
		 JFrame aux=new JFrame();
		 JOptionPane option = new JOptionPane();
		 aux.getContentPane().add(option);
		 aux.setVisible(true);
		 aux.setLocation(750,160);
	    int confirm = JOptionPane.showConfirmDialog(aux,"Are you sure you would like to delete\n"+
							"this single box from the annotation?",
							"Delete Box?", JOptionPane.YES_NO_OPTION);
		 aux.setVisible(false);
	    if (confirm == 0) {
		streamPanel.deleteIndBox(iBSelected);
		resetIBDisplay();
		hasSaved = false;
	    }
	}
    }

    /** 
     * Used to update the iBPanel to reflect changes made to the data
     * structure.
     */
    public void resetIBDisplay() {
	int index = streamPanel.getSelected();
	if (index < FrameData.SINGLE_BOXES) {
	    iBOptions.setSelectedIndex(index);
	    iBSelected = index;
	}
	axisTextField.setText(String.valueOf(streamPanel.getIBAxis(iBSelected)));
	appearCheckBox.setSelected(streamPanel.getIBAppear(iBSelected));
	disappearCheckBox.setSelected(streamPanel.getIBDisappear(iBSelected));
	occludedCheckBox.setSelected(streamPanel.getIBOccluded(iBSelected));
	programUpdate = true;
	if (streamPanel.getIBActive(iBSelected) == true && movementComboBox.getSelectedIndex() != IB_ACTIVE) {
	    movementComboBox.setSelectedIndex(IB_ACTIVE);
	} else if (streamPanel.getIBInActive(iBSelected) == true && movementComboBox.getSelectedIndex() != IB_INACTIVE) {
	    movementComboBox.setSelectedIndex(IB_INACTIVE);
	} else if (streamPanel.getIBWalk(iBSelected) == true && movementComboBox.getSelectedIndex() != IB_WALK) {
	    movementComboBox.setSelectedIndex(IB_WALK);
	} else if (streamPanel.getIBRun(iBSelected) == true && movementComboBox.getSelectedIndex() != IB_RUN) {
	    movementComboBox.setSelectedIndex(IB_RUN);
	} else if (streamPanel.getIBNoneMov(iBSelected) == true && movementComboBox.getSelectedIndex() != NONE_MOV) {
	    movementComboBox.setSelectedIndex(NONE_MOV);
	}
	programUpdate = false;	programUpdate = true;
	//Added to manipulate IRoles 
	if (streamPanel.getIBFighter(iBSelected) == true && iRolesComboBox.getSelectedIndex() != IR_FIGHTER) {
	    iRolesComboBox.setSelectedIndex(IR_FIGHTER);
	} else if (streamPanel.getIBBrowser(iBSelected) == true && iRolesComboBox.getSelectedIndex() != IR_BROWSER) {
	    iRolesComboBox.setSelectedIndex(IR_BROWSER);
	} else if (streamPanel.getIBLeftBehind(iBSelected) == true && iRolesComboBox.getSelectedIndex() != IR_LEFT_VICTIM) {
	    iRolesComboBox.setSelectedIndex(IR_LEFT_VICTIM);
	} else if (streamPanel.getIBWalker(iBSelected) == true && iRolesComboBox.getSelectedIndex() != IR_WALKER){
	    iRolesComboBox.setSelectedIndex(IR_WALKER);
	} else if (streamPanel.getIBLeftObject(iBSelected) == true && iRolesComboBox.getSelectedIndex() != IR_LEFT_OBJECT){
	    iRolesComboBox.setSelectedIndex(IR_LEFT_OBJECT);
	} else if (streamPanel.getIBNoneRol(iBSelected) == true && iRolesComboBox.getSelectedIndex() != NONE_ROL){
	    iRolesComboBox.setSelectedIndex(NONE_ROL);
	}	
	programUpdate = false;	programUpdate = true;
	//Added to manipulate IRoles 
	if (streamPanel.getIBInactiveSit(iBSelected) == true && iSitComboBox.getSelectedIndex() != SIT_INACTIVE) {
	    iSitComboBox.setSelectedIndex(SIT_INACTIVE);
	} else if (streamPanel.getIBMovingSit(iBSelected) == true && iSitComboBox.getSelectedIndex() != SIT_MOVING) {
	    iSitComboBox.setSelectedIndex(SIT_MOVING);
	} else if (streamPanel.getIBBrowsingSit(iBSelected) == true && iSitComboBox.getSelectedIndex() != SIT_BROWSING) {
	    iSitComboBox.setSelectedIndex(SIT_BROWSING);
	} else if (streamPanel.getIBshopenterSit(iBSelected) == true && iSitComboBox.getSelectedIndex() != SIT_SHOP_ENTER){
	    iSitComboBox.setSelectedIndex(SIT_SHOP_ENTER);
	} else if (streamPanel.getIBshopexitSit(iBSelected) == true && iSitComboBox.getSelectedIndex() != SIT_SHOP_EXIT){
	    iSitComboBox.setSelectedIndex(SIT_SHOP_EXIT);
	} else if (streamPanel.getIBNoneSit(iBSelected) == true && iSitComboBox.getSelectedIndex() != NONE_SIT){
	    iSitComboBox.setSelectedIndex(NONE_SIT);
	}
	programUpdate = false;programUpdate = true;
	//Added to manipulate IRoles 
	if (streamPanel.getIBBrowsing(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_BROWSING) {
	    iSceComboBox.setSelectedIndex(SCE_BROWSING);
	} else if (streamPanel.getIBImmobile(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_INMOBILE) {
	    iSceComboBox.setSelectedIndex(SCE_INMOBILE);
	} else if (streamPanel.getIBWalking(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_WALKING) {
	    iSceComboBox.setSelectedIndex(SCE_WALKING);
	} else if (streamPanel.getIBDropDown(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_DROP_DOWN) {
	    iSceComboBox.setSelectedIndex(SCE_DROP_DOWN);
	} else if (streamPanel.getIBwindowshopSce(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_WINDOW_SHOP){
	    iSceComboBox.setSelectedIndex(SCE_WINDOW_SHOP);
	} else if (streamPanel.getIBshopenterSce(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_SHOP_ENTER){
	    iSceComboBox.setSelectedIndex(SCE_SHOP_ENTER);
	} else if (streamPanel.getIBshopexitSce(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_SHOP_EXIT){
	    iSceComboBox.setSelectedIndex(SCE_SHOP_EXIT);
	} else if (streamPanel.getIBshopreenterSce(iBSelected) == true && iSceComboBox.getSelectedIndex() != SCE_SHOP_REENTER){
	    iSceComboBox.setSelectedIndex(SCE_SHOP_REENTER);
	} else if (streamPanel.getIBNoneSce(iBSelected) == true && iSceComboBox.getSelectedIndex() != NONE_SCE){
	    iSceComboBox.setSelectedIndex(NONE_SCE);
	} 

//	System.out.println("the index from streamPanel is "+streamPanel.getbodyPartSelected()+" the index from combobox "+bodyComboBox.getSelectedIndex());
	if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_BOX && bodyComboBox.getSelectedIndex()!=BODY_BOX){
		bodyComboBox.setSelectedIndex(BODY_BOX);
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_HEAD && bodyComboBox.getSelectedIndex()!=BODY_HEAD){
//		System.out.println("here setting to head ");
		bodyComboBox.setSelectedIndex(BODY_HEAD);
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_GAZE && bodyComboBox.getSelectedIndex()!=BODY_GAZE){
		bodyComboBox.setSelectedIndex(BODY_GAZE);
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_RIGHT_HAND && bodyComboBox.getSelectedIndex()!=BODY_R_HAND){
		bodyComboBox.setSelectedIndex(BODY_R_HAND);	
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_LEFT_HAND && bodyComboBox.getSelectedIndex()!=BODY_L_HAND){
		bodyComboBox.setSelectedIndex(BODY_L_HAND);	
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_RIGHT_FOOT && bodyComboBox.getSelectedIndex()!=BODY_R_FOOT){
		bodyComboBox.setSelectedIndex(BODY_R_FOOT);			
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_LEFT_FOOT && bodyComboBox.getSelectedIndex()!=BODY_L_FOOT){
		bodyComboBox.setSelectedIndex(BODY_L_FOOT);	
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_RIGHT_SHOULDER && bodyComboBox.getSelectedIndex()!=BODY_R_SHOULDER){
		bodyComboBox.setSelectedIndex(BODY_R_SHOULDER);	
	}else if (streamPanel.getbodyPartSelected()==ImagePanel.BODY_SEL_LEFT_SHOULDER && bodyComboBox.getSelectedIndex()!=BODY_L_SHOULDER){
		bodyComboBox.setSelectedIndex(BODY_L_SHOULDER);	
	}	
	if (streamPanel.bodySingleBoxisEmpty())
		bodyStatusLabel.setText("EMPTY BODY");
	else
		bodyStatusLabel.setText("BODY PARTS SET");
	bodyCheckBox.setSelected(streamPanel.getbodyPartSelectedState());
	streamPanel.refreshScreen();			
	programUpdate = false;
    }
    
    private void personImmobileCheckBoxActionPerformed(ActionEvent evt) {
	if (!singleSelected) {
	    groupSelectedErrorMessage(); 
	} else {
	    streamPanel.setIBPersonImmobile(iBSelected);
	    hasSaved = false;
	}
	resetIBDisplay();
    }

    private void movementComboBoxActionPerformed(ActionEvent evt) {
//    System.out.println("se dispara movementComboBoxActionPerformed "+programUpdate);
	if (programUpdate) ; // do nothing
	else if (!singleSelected) {
	    groupSelectedErrorMessage();
	} else {
//		System.out.println("update the movement combo box ");	
	    int movement = movementComboBox.getSelectedIndex();
	    if (movement == IB_ACTIVE && streamPanel.getIBActive(iBSelected) != true) {
		streamPanel.setIBActive(iBSelected);
	    } else if (movement == IB_INACTIVE && streamPanel.getIBInActive(iBSelected) != true) {
		streamPanel.setIBInActive(iBSelected);
	    } else if (movement == IB_WALK && streamPanel.getIBWalk(iBSelected) != true) {
		streamPanel.setIBWalk(iBSelected);
	    } else if (movement == IB_RUN && streamPanel.getIBRun(iBSelected) != true) {
		streamPanel.setIBRun(iBSelected);
	    } else if (movement == NONE_MOV && streamPanel.getIBNoneMov(iBSelected) != true) {
		streamPanel.setIBNoneMov(iBSelected);
	    }
	    hasSaved = false;
	}
	resetIBDisplay();
    }

    private void iRolesComboBoxActionPerformed(ActionEvent evt) {
//    System.out.println("se dispara iRolesComboBoxActionPerformed "+programUpdate);
	if (programUpdate) ; // do nothing
	else if (!singleSelected) {
	    groupSelectedErrorMessage();
	} else {
	    int role = iRolesComboBox.getSelectedIndex();
//		System.out.println("update the iroles "+role);
	    if (role == IR_BROWSER && streamPanel.getIBBrowser(iBSelected) != true) {
		streamPanel.setIBBrowser(iBSelected);
//		System.out.println("lo llama iRolesComboAction");
	    } else if (role == IR_FIGHTER && streamPanel.getIBFighter(iBSelected) != true) {
		streamPanel.setIBFighter(iBSelected);
	    } else if (role == IR_LEFT_OBJECT && streamPanel.getIBLeftObject(iBSelected) != true) {
		streamPanel.setIBLeftObject(iBSelected);
	    } else if (role == IR_WALKER && streamPanel.getIBWalker(iBSelected) != true) {
		streamPanel.setIBWalker(iBSelected);
	    } else if (role == IR_LEFT_VICTIM && streamPanel.getIBLeftBehind(iBSelected) != true) {
		streamPanel.setIBLeftBehind(iBSelected);
	    /*} else if (role == IR_LEAVING_GROUP && streamPanel.getIBLeavingGroup(iBSelected) != true) {
		streamPanel.setIBLeavingGroup(iBSelected);*/
	    }else if (role == NONE_ROL && streamPanel.getIBNoneRol(iBSelected) != true) {
		streamPanel.setIBNoneRol(iBSelected);
	    }
	    hasSaved = false;
	}
	resetIBDisplay();
    }

    private void iSitComboBoxActionPerformed(ActionEvent evt) {
//    System.out.println("se dispara iSitComboBoxActionPerformed "+programUpdate);

	if (programUpdate) ; // do nothing
	else if (!singleSelected) {
	    groupSelectedErrorMessage();
	} else {
	    int sit = iSitComboBox.getSelectedIndex();
	    if (sit == SIT_MOVING && streamPanel.getIBMovingSit(iBSelected) != true) {
		streamPanel.setIBMovingSit(iBSelected);
	    } else if (sit == SIT_INACTIVE && streamPanel.getIBInactiveSit(iBSelected) != true) {
		streamPanel.setIBInactiveSit(iBSelected);
	    } else if (sit == SIT_BROWSING && streamPanel.getIBBrowsingSit(iBSelected) != true) {
		streamPanel.setIBBrowsingSit(iBSelected);
	    } else if (sit == SIT_SHOP_ENTER && streamPanel.getIBshopenterSit(iBSelected) != true) {
		streamPanel.setIBshopenterSit(iBSelected);
	    } else if (sit == SIT_SHOP_EXIT && streamPanel.getIBshopexitSit(iBSelected) != true) {
		streamPanel.setIBshopexitSit(iBSelected);
	    } else if (sit == NONE_SIT && streamPanel.getIBNoneSit(iBSelected) != true) {
		streamPanel.setIBNoneSit(iBSelected);
	    }
	    hasSaved = false;
	}
	resetIBDisplay();
    }

    private void iSceComboBoxActionPerformed(ActionEvent evt) {
//    System.out.println("se dispara iSceComboBoxActionPerformed "+programUpdate);

	if (programUpdate) ; // do nothing
	else if (!singleSelected) {
	    groupSelectedErrorMessage();
	} else {
	    int sce = iSceComboBox.getSelectedIndex();
	    if (sce == SCE_BROWSING && streamPanel.getIBBrowsing(iBSelected) != true) {
		streamPanel.setIBBrowsing(iBSelected);
	    } else if (sce == SCE_INMOBILE && streamPanel.getIBImmobile(iBSelected) != true) {
		streamPanel.setIBImmobile(iBSelected);
	    } else if (sce == SCE_WALKING && streamPanel.getIBWalking(iBSelected) != true) {
		streamPanel.setIBWalking(iBSelected);
	    } else if (sce == SCE_WINDOW_SHOP && streamPanel.getIBwindowshopSce(iBSelected) != true) {
		streamPanel.setIBwindowshopSce(iBSelected);
	    } else if (sce == SCE_SHOP_ENTER && streamPanel.getIBshopenterSce(iBSelected) != true) {
		streamPanel.setIBshopenterSce(iBSelected);
	    } else if (sce == SCE_SHOP_EXIT && streamPanel.getIBshopexitSce(iBSelected) != true) {
		streamPanel.setIBshopexitSce(iBSelected);
	    } else if (sce == SCE_SHOP_REENTER && streamPanel.getIBshopreenterSce(iBSelected) != true) {
		streamPanel.setIBshopreenterSce(iBSelected);
	    } else if (sce == SCE_DROP_DOWN && streamPanel.getIBDropDown(iBSelected) != true) {
		streamPanel.setIBDropDown(iBSelected);
	    } else if (sce == NONE_SCE && streamPanel.getIBNoneSce(iBSelected) != true) {
		streamPanel.setIBNoneSce(iBSelected);
	    }

	    hasSaved = false;
	}
	resetIBDisplay();
    }



    
    /**
     * Checks whether it is this single box that is selected
     * using singleSelected, toggles the occluded truth in the selected SingleBox
     * object and then resets the display
     */
    private void occludedCheckBoxActionPerformed(ActionEvent evt){ 
	if (!singleSelected) {
	    groupSelectedErrorMessage();
	} else {
	    streamPanel.setIBOccluded(iBSelected);
	    hasSaved = false;;
	}
	resetIBDisplay();
    }

	private void bodyCheckBoxActionPerformed(ActionEvent evt){ 
	if (!singleSelected) {
		groupSelectedErrorMessage();
	} else {
		SingleBox single=streamPanel.getSingleBoxSelected();
		if (single!=null){
			if (streamPanel.getbodyPartSelected()!=ImagePanel.BODY_SEL_BOX){
				boolean state=bodyCheckBox.isSelected();
				System.out.println("body check box value is "+state);
				if (state==true)
					state=false;
				else
					state=true;
				streamPanel.setBodyPartState(state);
				hasSaved = false;
			}else{
				JOptionPane.showMessageDialog(null,"Current part selected is the box",
								  "Warning",
								  JOptionPane.WARNING_MESSAGE);
				bodyCheckBox.setSelected(false);
				}
		}else{
			JOptionPane.showMessageDialog(null,"The current box has not been draw, first draw the box",
							  "Warning",
							  JOptionPane.WARNING_MESSAGE);
			bodyCheckBox.setSelected(false);				  			
		}
	}
	resetIBDisplay();
	}
	
	private void bodyselActionPerformed(ActionEvent evt){
		System.out.println("here switching for body selected");
		streamPanel.setShowCurrentSelectionTags();
		streamPanel.repaint();	
	}	
	
	private void bodyDispAllActionPerformed(ActionEvent evt){ 
		streamPanel.setShowAllBodyBoxes();
		streamPanel.repaint();			
	}
	
	private void bodyDispAllLabelsActionPerformed(ActionEvent evt){ 
		streamPanel.setShowAllBodyTags();
		streamPanel.repaint();	
	}

	

	private void showBoxNamesActionPerformed(ActionEvent evt){ 
		streamPanel.setBoxNames();
		streamPanel.repaint();	
	}

    /** 
     * Checks whether it is this single box that is selected
     * using singleSelected, toggles the disappear truth in the selected SingleBox
     * object and then resets the display
     */
    private void disappearCheckBoxActionPerformed(ActionEvent evt) {
	if (!singleSelected) {
	    groupSelectedErrorMessage();
	} else {
	    streamPanel.setIBDisappear(iBSelected);
	    hasSaved = false;
	}	    
	resetIBDisplay();
    }

    
    /** 
     * Checks whether it is this single box that is selected
     * using singleSelected, toggles the left behind truth in the selected SingleBox
     * object and then resets the display
     */
    private void appearCheckBoxActionPerformed(ActionEvent evt) {
	if (!singleSelected) {
	    groupSelectedErrorMessage();
	} else {
	    streamPanel.setIBAppear(iBSelected);
	    hasSaved = false;
	}
	resetIBDisplay();
    }

    /** 
     * Checks whether it is this individual (single) box that is selected
     * using singleSelected, alters the axis of orientation in the selected SingleBox
     * object and then resets the display (including the image in streamPanel)
     */
    private void axisTextFieldActionPerformed(ActionEvent evt) {
	// default set to 90, if there is a number format exception
	// ie a string is entered and not a number then show error 
	// message. if the value is outside 0 to 179, then show error
	// message. if an error message is shown reset to default
	if (!singleSelected) {
	    groupSelectedErrorMessage(); resetIBDisplay();
	} else {
	    int update = 0;
	    try {
		update = Integer.valueOf(axisTextField.getText()).intValue();
	    } catch(NumberFormatException e){
		JOptionPane.showMessageDialog(iBPanel,
					  ("Invalid angle - "+
					   axisTextField.getText()+
					   "\nMust be in range 0 to 179"),
					      "Invalid Value",
					      JOptionPane.WARNING_MESSAGE); 
		return;
	    }
	    if (update < 0 || update > 179) {
		JOptionPane.showMessageDialog(iBPanel,
					  ("Invalid angle - "+
					   axisTextField.getText()+
					   "\nMust be in range 0 to 179"),
					      "Invalid Value",
					      JOptionPane.WARNING_MESSAGE); 
	    } else {
		streamPanel.setIBAxis(iBSelected,update);
	    }
	    hasSaved = false;
	}
    }

    /** 
     * Used to add 1 degree to the axis of orientation. Could be improved
     * by allowing the user to hold down the button or specfy a greater
     * angle to change the orientation by. Uses same error detection/correction
     * as updateIBAxis
     */
    private void plusIBAxisButtonActionPerformed(ActionEvent evt) {
	if (!singleSelected) {
	    groupSelectedErrorMessage(); resetIBDisplay();
	} else {
	    int update = streamPanel.getIBAxis(iBSelected);
	    if (update == 179) {
		streamPanel.setIBAxis(iBSelected,0);
		axisTextField.setText("0");
	    } else {
		streamPanel.setIBAxis(iBSelected,update+1);
		axisTextField.setText(String.valueOf(update+1));
	    }
	    hasSaved = false;
	}
    }
    
    /** 
     * Used to take away 1 degree to the axis of orientation. Could be improved
     * by allowing the user to hold down the button or specfy a greater
     * angle to change the orientation by. Uses same error detection/correction
     * as updateIBAxis
     */
    private void minusIBAxisButtonActionPerformed(ActionEvent evt) {
	if (!singleSelected) {
	    groupSelectedErrorMessage(); resetIBDisplay();
	} else {
	    int update = streamPanel.getIBAxis(iBSelected);
	    if (update == 0) {
		streamPanel.setIBAxis(iBSelected,179);
		axisTextField.setText("179");
	    } else {
		streamPanel.setIBAxis(iBSelected,update-1);
		axisTextField.setText(String.valueOf(update-1));
	    }
	    hasSaved = false;
	}
    }

    /** 
     * Exit the Application 
     * Same as the exit button, checks whether the file has been
     * edited using the hasSaved field and if not it will ask the user if they 
     * wish to save the changes
     */
    private void exitForm(WindowEvent evt) {
	if (!hasSaved) {
	    // variable yes, yes = 0 no = 1
	    int confirm = JOptionPane.showConfirmDialog(fileButtonPanel,"Annotations to the frames have not been saved\n"+
						"Would you like to save first?",
					      "Save Edited Frames", JOptionPane.YES_NO_OPTION);
	    if (confirm == 0) {
		// bring up save file window
		String s = JOptionPane.showInputDialog(null,
						       ("Enter file name you wish to save data as:\n"),
						       "Save file",
						       JOptionPane.PLAIN_MESSAGE);
		
		if ((s != null) && (s.length() > 0)) {
		    streamPanel.saveAsFile(s);
		    System.exit(0);
		} else {
		    JOptionPane.showMessageDialog(null,
						  ("No file name specified"),
						  "Save File Warning",
						  JOptionPane.WARNING_MESSAGE);
		}
	    } else {
		System.exit(0);
	    }
	}
	
	else { System.exit(0);}
	
	
    }
    
    /**
     * Error message to indicate that an attempt has been made
     * to edit a single box when it is a group box is selected.
     * Used to simplify tracking of changes to the frame
     */
    private void groupSelectedErrorMessage() {
	JOptionPane.showMessageDialog(null,
				      ("Group box "+gBSelected+" is the selected box\n"),
				      "Selection Error",
				      JOptionPane.WARNING_MESSAGE);
    }

     /**
     * Error message to indicate that an attempt has been made
     * to edit a group box when it is a sinlge box is selected.
     * Used to simplify tracking of changes to the frame
     */
    private void singleSelectedErrorMessage() {
	JOptionPane.showMessageDialog(null,
				      ("Single box "+iBSelected+" is the selected box\n"),
				      "Selection Error",
				      JOptionPane.WARNING_MESSAGE);
    }

    /**
     * Error message to indicate that an attempt has been made
     * to delete a group box that has does not exist.
     * Used to simplify tracking of changes to the frame
     */
    private void deleteEmptyGBoxMessage() {
	 JFrame aux=new JFrame();
	 JOptionPane option = new JOptionPane();
	 aux.getContentPane().add(option);
	 aux.setVisible(true);
	 aux.setLocation(900,160);
	JOptionPane.showMessageDialog(aux,
				      ("The group box "+gBSelected+" has not been created\n"),
				      "Selection Error",
				      JOptionPane.WARNING_MESSAGE);
	 aux.setVisible(false);
    }

    /**
     * Error message to indicate that an attempt has been made
     * to delete a ind box that has does not exist.
     * Used to simplify tracking of changes to the frame
     */
    private void deleteEmptyIBoxMessage() {
	 JFrame aux=new JFrame();
	 JOptionPane option = new JOptionPane();
	 aux.getContentPane().add(option);
	 aux.setVisible(true);
	 aux.setLocation(750,160);
	JOptionPane.showMessageDialog(aux,
				      ("The ind box "+iBSelected+" has not been created\n"),
				      "Selection Error",
				      JOptionPane.WARNING_MESSAGE);
	 aux.setVisible(false);
    }
    
    
     /**
     * Error message to indicate that an attempt has been made
     * to delete a ind box that has does not exist.
     * Used to simplify tracking of changes to the frame
     */
    private void deleteIBox_inGBoxMessage() {
	 JFrame aux=new JFrame();
	 JOptionPane option = new JOptionPane();
	 aux.getContentPane().add(option);
	 aux.setVisible(true);
	 aux.setLocation(750,160);
	JOptionPane.showMessageDialog(aux,
				      ("The ind box "+iBSelected+" it's in one or some Groups Boxes\n remove its links to all the group boxes prior to deletion \n"),
				      "Selection Error",
				      JOptionPane.WARNING_MESSAGE);
	 aux.setVisible(false);
    }

    
    /**
     * Main method that starts the CAVIARGUI program. Everything in the caviargui
     * is related to this. Simply creates a new CAVIARGUI object and then calls
     * show() to initialise the GUI
     *
     * @param args the command line arguments
     */
    public static void main(String args[]) {
	new CAVIARGUI().setVisible(true);
    }    
    
    // Variables declaration

    /** The variables from START consist of the JPanels, JButtons, JTextFields,
     * JLabels and JCheckBoxes that make up the GUI. Any additions/deletions
     * should be added/removed from this list
     * START
     */
    
    // image panel params
    private ImagePanel streamPanel;
    
    // individual box panel params

    private JLabel axisLabel;
    private JTextField axisTextField;
    private JLabel iBLabel;
    private JComboBox iBOptions;
    private JPanel iBPanel;
    private JButton iBDeleteButton;
    private JPanel updateIBAxisPanel;
    private JButton plusAxisButton;
    private JButton minusAxisButton;
    // appearance
    private JLabel iBADLabel;
    private JCheckBox appearCheckBox;
    private JCheckBox disappearCheckBox;
    private JCheckBox occludedCheckBox;
    // movement
    private JLabel iBActiveLabel;
    private JComboBox movementComboBox;
    // roles
    private JLabel indRoles;
    private JComboBox iRolesComboBox;
    // situations
    private JLabel situationsLabel;
    private JComboBox iSitComboBox;
    // scenarios
    private JLabel scenariosLabel;
	 private JComboBox iSceComboBox;
    // events
    private JLabel eventsLabel;
    private JCheckBox personImmobileCheckBox;

    // group box panel params
    private JLabel axisGBLabel;
    private JTextField axisGBTextField;
    private JLabel gBLabel;
    private JPanel gBPanel;
    private JLabel gBIBLabel;
    private JTextField gBIBTextField;
    private JLabel gBIBSelectedLabel;
    private JLabel gBIBDisplaySelected;
    private String gBIBText;
    private String gBIBUpdateText;
    private JTextArea gBIBTextArea;
    private JComboBox gBOptions;
    private JButton gBDeleteButton;
    private JButton plusGBAxisButton;
    private JButton minusGBAxisButton;
    private JPanel updateGBAxisPanel;
    // appearance
    private JLabel gBADLabel;
    private JCheckBox gAppearCheckBox;
    private JCheckBox gDisappearCheckBox;
    // movement
    private JLabel gBMovementLabel;
    private JComboBox gMovementComboBox;
    // roles
    private JComboBox gRolComboBox;
    private JLabel groupRoles;
   
    // situations
    private JComboBox gSitComboBox;    
    private JLabel gSituationsLabel;

    // scenarios
    private JComboBox gSceComboBox;    
    private JLabel gScenarioLabel;

    // events
    private JLabel gEventsLabel;
    private JCheckBox fightStartCheckBox;
    private JCheckBox fightEndCheckBox;
    private JCheckBox fightLeftVictimCheckBox;

    // file options panel
    private JPanel fileButtonPanel;
    private JLabel fileOptionsLabel;
    private JButton copyToNext;
    private JButton copyToPrev;
    private JButton exitFrame;
    private JButton nextFrame;
    private JButton prevFrame;
    private JButton copyBox;
    private JButton copyBody;
    private JButton copyTruths;
    private JButton resetFrame;
    private JButton resetAll;
    private JButton jumpToFrame;
    private JButton saveFile;
    private JButton saveFileAs;
    private JButton loadFile;
    private JButton loadNewSeq;
    private JCheckBox performCheck;
    
    //GREGOR
    private cpBoxAction copyBoxAction;
	private cpBodyAction copyBodyAction;
    private cpTruthsAction copyTruthsAction;
    private prevAction prevAction;
    private nextAction nextAction;
    private plusIBAction plusIBAction;
    private minusIBAction minusIBAction;
    private plusGBAction plusGBAction;
    private minusGBAction minusGBAction;
    //END GREGOR

    private JLabel blank2;
    private JLabel blank3;
    private JLabel blank4;
    private JLabel blank5;
    private JLabel blank6;
    private JLabel blank7;


	
    
    /** determines which box number is currently selected */
    private int gBSelected = 0;
    private int iBSelected = 0;
    /** flag that determines whether it is a single or a group box that is selected */
    private boolean singleSelected = true;
    /** flag to check whether the user has saved their program before
     * exiting */
    private boolean hasSaved = false;
    /** string to store the name of the current file for data from editing
     * to be saved */
    private String saveFileString = "";
    /** Button added to preview video stream */
    private JButton play;
    /** Image height and width, change these if no longer using half PAL size */
    protected static final int WIDTH = 384, HEIGHT = 288, SCALE = 2;
    /** Positions in the JComboBoxes used for the Individual Box Movement infomation */
    protected static final int NONE_MOV = 0, IB_INACTIVE = 1, IB_ACTIVE = 2, IB_WALK = 3, IB_RUN = 4;
    /** Positions in the JComboBoxes used for the Individual Box Movement infomation */
    protected static final int GBNONE_MOV = 0, GB_INACTIVE = 1, GB_ACTIVE = 2, GB_MOVE = 3;
    //added by jose
    /** Positions in the JComboBoxes used for the Individual Box Movement infomation */
    protected static final int NONE_ROL=0,IR_BROWSER = 1, IR_WALKER = 2, IR_FIGHTER = 3, IR_LEFT_VICTIM = 4, /*IR_LEAVING_GROUP = 5,*/ IR_LEFT_OBJECT = 5;
    protected static final int NONE_SIT=0, SIT_MOVING=1, SIT_INACTIVE=2, SIT_BROWSING=3, SIT_SHOP_ENTER=4, SIT_SHOP_EXIT=5;
    protected static final int NONE_SCE=0, SCE_BROWSING=1, SCE_INMOBILE=2, SCE_WALKING=3, SCE_DROP_DOWN=4, SCE_WINDOW_SHOP=5,SCE_SHOP_ENTER=6,SCE_SHOP_EXIT=7,SCE_SHOP_REENTER=8;    

	/**Positions in the JComboBoxes used for the Individual Box Movement infomation */
	protected static final int GBNONE_ROL=0,GBFIGHTERS=1,GBBROWSERS=2,GBMEETERS=3,GBWALKERS=4; 
	protected static final int GBNONE_SIT=0,GBBROWSING_SIT=1,GBFIGHTING_SIT=2,GBMOVING_SIT=3,GBMEETING_SIT=4,GBINTERACT_SIT=5,GBSPLITTING_SIT=6,GBINACTIVE_SIT=7,GBSHOPENTER_SIT=8,GBSHOPEXIT_SIT=9,GBLEAVING_SIT=10,GBLEAVINGOBJ_SIT=11;
	protected static final int GBNONE_SCE=0,GBFIGHTING_SCE=1,GBWALKING_SCE=2,GBMEETING_SCE=3,GBWINDOWSHOP_SCE=4,GBSHOPENTER_SCE=5,GBSHOPEXIT_SCE=6,GBSHOPREENTER_SCE=7,GBLEAVING_SCE=8;

	/**Positions for JComboBox for body parts*/
	protected static final int BODY_BOX=0,BODY_HEAD=1,BODY_GAZE=2,BODY_R_SHOULDER=3,BODY_L_SHOULDER=4,BODY_R_HAND=5,BODY_L_HAND=6,BODY_R_FOOT=7,BODY_L_FOOT=8;

    // set of colour that show up clearly on grey background to indicate 
    // groups
    private Color ORANGE = new Color(228,107,38);
    private Color GREEN = new Color(24,163,36);
    private Color YELLOW = new Color(137,122,11);
    private Color PURPLE = new Color(121,24,163);
    // hack, used to prevent single/groupSelected errors from occuring when
    // a setSelectedIndex event has occurred via the program through resetIB/GBDisplay
    // and not through user actions
    private boolean programUpdate = false;
    
	private KeyDAction keyDAction;	
	private Key1Action key1Action;
	private Key2Action key2Action;
	private Key3Action key3Action;
	private Key4Action key4Action;
	private Key5Action key5Action;
	private Key6Action key6Action;
	private Key7Action key7Action;
	private Key8Action key8Action;
	private Key9Action key9Action;
	private KeyEAction keyEAction;
	private KeyZAction keyZAction;	
	private KeyAAction keyAAction;
	private KeySAction keySAction;	
	private KeyXAction keyXAction;
	private KeyCAction keyCAction;
	
	//elements for body
	private JLabel bodyLabel=null;
	private JComboBox bodyComboBox=null;
	private JCheckBox bodyCheckBox=null;
	private JLabel bodyStatusLabel=null;
	private JLabel bodyIncLabel=null;
	private JTextField bodyIncTextField=null;
	private JLabel bodyDispLabel=null;
	private JCheckBox bodyselBodyLabels=null;
	private JCheckBox bodyDisplayAll=null;
	private JCheckBox bodyDisplayAllLabels=null;	
	private JCheckBox showBoxNames=null;
	
	
}
